/**
 * Created by htzhanglong on 2015/8/2.
 */
// Ionic Starter App

var citsApp = angular.module('cits',
    ['ionic', 'ngFileUpload', 'pasvaz.bindonce', 'ngResource', 'ngIOS9UIWebViewPatch', 'mobiscroll-datetime',
     'mobiscroll-form', 'ngCookies', 'ngSanitize']);
/*
 * */
citsApp.run(['$rootScope', '$location', '$state', 'HostFactory', '$ionicLoading', '$ionicPlatform', 'CommonFactory', 'Storage', 'ENV',
             '$ionicHistory', '$timeout', 'Session', 'LoginFactory', 'PopupFactory', '$ionicBackdrop', '$ionicViewSwitcher',
    'WehatBindingFactory', 'WxPayFactory', 'MsgPushFactory', '$ionicModal',
    "memberPresonalInfoFactory",
    'LoginInfoTrackFactory', '$q', 'CommonFactory', '$timeout',
             function ($rootScope, $location, $state, HostFactory, $ionicLoading, $ionicPlatform, CommonFactory, Storage, ENV,
                       $ionicHistory, $timeout, Session, LoginFactory, PopupFactory, $ionicBackdrop, $ionicViewSwitcher,
                 WehatBindingFactory, WxPayFactory, MsgPushFactory, $ionicModal,
                 memberPresonalInfoFactory,
              LoginInfoTrackFactory, $q, CommonFactory, $timeout) {
    $rootScope.cordova = true;
    $rootScope.deviceWidth = document.body.clientWidth;
    $rootScope.deviceHeight = (document.body.clientHeight == 0 ? document.querySelector('.backdrop').clientHeight : document.body.clientHeight);
    if (!window.cordova) {
        $rootScope.deviceWidth = $rootScope.deviceWidth > 640 ? 640 : $rootScope.deviceWidth;
        $rootScope.cordova = false;

    }

    CITS.initTraffic();
    CITS.info.unique = Storage.get(ENV.CITS_UUID_KEY) ? Storage.get(ENV.CITS_UUID_KEY) : CITS.duuid;
    Storage.set(ENV.CITS_UUID_KEY, CITS.info.unique);
    //Tab广告
    $rootScope.tabAdInfo = Storage.get(ENV.TAB_AD_KEY) ? Storage.get(ENV.TAB_AD_KEY) : new TabAd();
    //定义变量 ios_app; 默认为我和旅行
                 $rootScope.iosAppType = true;
    // 小程序类型判断
    $rootScope.showAccountType = false;
                 $rootScope.showHomeLow = false;
    $rootScope.showWapType = false;
    $ionicPlatform.ready(function () {

        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)

        try {
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);

                //延迟splash screnn 隐藏时间,不然会有短暂的白屏出现
                /*setTimeout(function () {
                 navigator.splashscreen.hide();
                 }, 2000);*/
            }
            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleLightContent();
            }
        } catch (e) {

        }
        if (window.cordova) {
            $ionicModal.fromTemplateUrl("templates/common/serviceOnline.htm", {
                scope: $rootScope,
                animation: "slide-in-up"
            }).then(function (modal) {
                $rootScope.serviceOnlineModal = modal;
            });
        }

        // Android处理返回键
        var backButtonHandler = function (e) {
            e.preventDefault();
            if ($location.path() == '/home') {
                // 双击退出
                if ($rootScope.backButtonPressedOnceToExit) {
                    $rootScope.quitApp();
                } else {
                    $rootScope.backButtonPressedOnceToExit = true;
                     PopupFactory.tipPopupOneSecond("再按一次退出应用");
                    setTimeout(function () {
                        $rootScope.backButtonPressedOnceToExit = false;
                    }, 2000);
                }
            } else if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            } else {
                $state.go('home');
            }

            return false;
        };
        $ionicPlatform.registerBackButtonAction(backButtonHandler, 100);

        CommonFactory.getCardType();
        // 首次加载或F5刷新加载，校验用户信息,如果不存在清除本地缓存,如果存在更新缓存信息
        if (CommonFactory.getUserInfo() != null) {
            $rootScope.$on('user.init', function () {
                $rootScope.userExistFlag = CommonFactory.userCheckResult();

                if (!$rootScope.userExistFlag) {
                    CommonFactory.clearUser();
                } else {
                    LoginFactory.getCacheMemberInfo('userCache.init', {userName: CommonFactory.getUserInfo().loginId});
                }
            });
            CommonFactory.checkUserExist('user.init');
        }
		
		//app首次加载时获取设备Id以及应用下载各个渠道标识字符串
		if (window.cordova) {

			var fail = function (e) {
            };
                var deviceFail = function (e) {

                };
                try { //安卓获取设备id
                    CustomBaseMainPlugin.collectDeivceType(function (r) {
                        var str = angular.fromJson(r);
                        CITS.deivceType.channel = str.channel; //设备渠道
                        if (ionic.Platform.isIOS()) {
                            CITS.deivceType.iosDeviceUDID = str.DeviceUDID;
                            CITS.deivceType.iosSimulateIDFA = str.SimulateIDFA;
                            CITS.deivceType.iosAppleIDFA = str.AppleIDFA;
                            CITS.deivceType.deviceType = "ios";
                        } else {
                            CITS.deivceType.androidDeviceUDID = str.DeviceUDID;
                            CITS.deivceType.androidID = str.AndroidID;
                            CITS.deivceType.deviceType = "android";
                        }
                        CITS.deivceType.deviceUDID = str.DeviceUDID; //设备ID
                    }, deviceFail, [{}]);
                } catch (e) {
                }

            //ios判断国旅在线和中国国旅
            if (window.cordova && (CITS.getChannelSource() == '07' || CITS.getChannelSource() == '08') ) {
                try {
                    CustomBaseMainPlugin.getBundidType(function (str) {
                        if (str == CITS.info.IOS_BUNDID_CITS_ONLINE) {
                            $rootScope.iosAppType = true;
                        } else {
                            $rootScope.iosAppType = false;
                            $rootScope.showModalInf();
                        }
                    }, function (e) {
                        $rootScope.iosAppType = false;
                        $rootScope.showModalInf();
                    }, []);
                } catch (e) {
                    // PopupFactory.tipPopup("请稍后...");
                    $rootScope.iosAppType = false;
                    $rootScope.showModalInf();
                }

            }
        }
    });

    // 判断是否为微信，调用小程序判断，其他不走小程序回调
                 //设备渠道处理
                 var ua = navigator.userAgent.toLowerCase();
                 if (ua.match(/MicroMessenger/i) == "micromessenger") { // 微信环境
         //处理微信小程序进去首页  start
         wx.miniProgram.getEnv(function (res) {
             if (res.miniprogram) {
                 $rootScope.showAccountType = true;
                 $rootScope.showWapType = false;
                 var r = new RegExp("(^|&?)uuid=([^&]*)(&|$)", "i");
                 var absUrl = $location.absUrl();
                 var rm = absUrl.match(r);
                 var wxlet = "";
                 if (rm != null) {
                     wxlet = unescape(rm[2]);
                     $rootScope.accountNumber = unescape(rm[2]);
                     wxlet = "wxlet_" + wxlet;
                 }
                 var cr = new RegExp("(^|&?)code=([^&]*)(&|$)", "i");
                 var cabsUrl = $location.absUrl();
                 var crm = cabsUrl.match(cr);
                 var code = "";
                 if (crm != null) {
                     code = unescape(crm[2]);
                 }
                 $rootScope.accountCode = code;
                 $rootScope.accountType = "wxlet";
                 if ((wxlet || '').length > 0) {
                     $rootScope.$on("getAutoMemberInfo", function () {
                         var mem = WehatBindingFactory.getAutoMemberInfo();
                     });
                     WehatBindingFactory.ziDongDL("getAutoMemberInfo", wxlet);
                 }
             } else {
                 $rootScope.showWapType = true;
                 $rootScope.showHomeLow = true;
             }
         });
     } else {
         $rootScope.showWapType = true;
         $rootScope.showHomeLow = true;
     }

     //处理微信小程序进去首页  end
    $rootScope.setJumpUrl = function (state, param) {
        Session.set('stateForRefresh', state);
        Session.set('paramForRefresh', param);
    },
        $rootScope.getJumpUrl = function () {
            var state = Session.get("stateForRefresh");
            var param = Session.get("paramForRefresh");
            $timeout(function () {
                $ionicHistory.clearHistory();
            }, 1000);
            if ((state || '').length > 0) {
                $state.go(state, param);
            } else {
                $state.go('home');
            }
        };
    if (window.cordova) {
        $rootScope.$on('mobileIndexTabAd.init', function () {
            var mobileIndexTabAd = CommonFactory.getAdList('mobileIndexTabAd');
            if((mobileIndexTabAd||"").length>0){
                var mobilead=mobileIndexTabAd[0];
                var tabAd= new TabAd();
                tabAd.ad_link=mobilead.ad_link;
                tabAd.ad_pic = ENV.imgUrl + mobilead.ad_pic;
                Storage.set(ENV.TAB_AD_KEY, tabAd);
                $rootScope.tabAdInfo = Storage.get(ENV.TAB_AD_KEY) ? Storage.get(ENV.TAB_AD_KEY) : new TabAd();
            }else{
                var tabAd= new TabAd();
                Storage.set(ENV.TAB_AD_KEY, tabAd);
            }
        });
        CommonFactory.loadAdList('mobileIndexTabAd.init', {
            channel: 'mobile',
            position: 'mobileIndexTabAd'
        }, 'mobileIndexTabAd');
    }
    /**
     * tab页面广告点击用，解决首次加载后链接获取不到的情况 DOTO
     * @returns {boolean}
     */
    $rootScope.goTabLink = function () {
        var adLik = $rootScope.tabAdInfo.ad_link;
        if (adLik) {
            var patrn = /^(http)/i;
            if (patrn.test(adLik)&&adLik.indexOf('m.ourtour.com')<0) {
                if (!window.cordova) {
                    $window.location.href = adLik;
                } else {
                    cordova.ThemeableBrowser.open(adLik, '_blank', {

                        title: {
                            color: '#000000',
                            showPageTitle: true
                        },
                        closeButton: {
                            wwwImage: 'img/close.png',
                            wwwImagePressed: 'img/close_pressed.png',
                            wwwImageDensity: 2,
                            align: 'right',
                        },
                        backButtonCanClose: true
                    });
                }
                return false;

            } else {
                if (adLik.indexOf('m.ourtour.com')>=0) {
                    var adurl =adLik.split("#");
                    if(adurl&&adurl.length>1){
                        adLik=adurl[1];
                    }else{
                        adLik='/home';
                    }
                }

                $timeout(function () {
                    $location.path(adLik).replace();//设置路由地址
                }, 1);

                return false;
            }
        } else {
            return false;
        }
    };
    $rootScope.$on('loading:show', function () {
        $ionicBackdrop.retain();
        $rootScope.showLoading = true;
    });

    $rootScope.$on('loading:hide', function () {
        $rootScope.showLoading = false;
        $ionicBackdrop.release();

    });
    $rootScope.tabhome = function () {
        $ionicViewSwitcher.nextTransition('none');

        $state.go('home');
        return false;
    };
    $rootScope.tabmember = function () {
        $ionicViewSwitcher.nextTransition('none');
        $state.go("member_index");
        return false;
    };
    // 清除模型
    $rootScope.$on('payDestroy', function () {
        $rootScope.payModal.remove();
    });

    //cordova
        loadURL.home = function () {
        	$ionicViewSwitcher.nextTransition('none');
            $state.go("home");
        };
        loadURL.member = function () {
        	$ionicViewSwitcher.nextTransition('none');
            $state.go("member_index");
        };

        loadURL.search = function () {
            $ionicViewSwitcher.nextTransition('none');
            $state.go("all_searchDest");
        };
        loadURL.showImage = function () {
            CITS.saveTraffic(false);
        };

        loadURL.hideImage = function () {
            CITS.saveTraffic(true);
        };
    loadURL.kefuBack = function () {
        $state.go("home");
    };
        loadURL.go = function (obj) {

            if (obj) {
                obj = eval("(" + obj + ")");
                if (obj.state) {
                    if (obj.params) {
                        $state.go(obj.state, obj.params);
                    } else {
                        if (obj.state == 'all_searchDest') {
                            $ionicViewSwitcher.nextTransition('none');
                            $state.go('all_searchDest', {'channel': '0'});
                        } else {

                            $state.go(obj.state);
                        }
                    }

                }

        }
        //$location.path(obj); 要用TIMEOUT
    };

    //h5唤起app跳转指定页面 //jumpType=0 走 $location.path(obj); jumpType=1 走 打开完整连接
    loadURL.wakeGo = function (obj, jumpType) {
        if (obj && jumpType) {
             if (jumpType == '0') {
                var paths = CITS.unavailablePath();
                var isContainObj = false; //paths里是否包含obj
                var objarr = obj.split('/order/detail');
                var objarr1 = obj.split('/book/success');
                if (objarr.length > 1 ||objarr1.length > 1) {
                    isContainObj = true;
                } else {
                    for (var i = 0; i <paths.length; i++) {
                        if (obj == paths[i]) {
                            isContainObj = true;
                            break;
                        }
                    }
                }
                if (isContainObj) {
                    loadURL.home();
                } else {

                    $timeout(function () {
                            if (obj && obj.indexOf('?') > 0) {
                                var url = obj.substring(0, obj.indexOf('?'));
                                var param = obj.substring(obj.indexOf('?') + 1);
                                var paramArr = param.split("&");
                                if (paramArr.length > 0) {
                                    var paramStr = {};
                                    for (var i = 0; i < paramArr.length; i++) {
                                        var p = paramArr[i].split("=");
                                        if (p.length == 2) {
                                            paramStr[p[0]] = p[1];
                                        }
                                    }
                                    if (paramStr != {}) {
                                        $location.path(url).search(paramStr);
                                    }
                                }
                            } else {
                                $location.path(obj);
                            }
                        }, 1);


                }
            } else if (jumpType == '1') {
                cordova.ThemeableBrowser.open(obj, '_blank', {
                    title: {
                        color: '#000000',
                        showPageTitle: true
                    },
                    closeButton: {
                        wwwImage: 'img/close.png',
                        wwwImagePressed: 'img/close_pressed.png',
                        wwwImageDensity: 2,
                        align: 'right'
                    },
                    backButtonCanClose: true
                 });
            }
         }
    };

    // 查询我的消息数量
    loadURL.resetMessageNum = function () {
        $rootScope.$on('queryMsgNum.init', function () {
            $rootScope.msgMap = MsgPushFactory.getMsgInfoReturn();
            $rootScope.allInfor = $rootScope.msgMap.allInfor;
        });

        MsgPushFactory.getMsgInfo('queryMsgNum.init', {login_id: CommonFactory.getUserInfo().loginId});
    };

    $rootScope.addTravelNotesFlg = true;
    $rootScope.addTravelNotes = function () {
        var win = function (r) {
            $ionicViewSwitcher.nextTransition('none');
            if (!$ionicHistory.backView()) {
                $state.go('home');
            }
            ($ionicHistory.backView() && $ionicHistory.backView().url.indexOf('login') > 0) ? $ionicHistory.goBack(-2) : $ionicHistory.goBack();
        };
        var fail = function (e) {
            $ionicViewSwitcher.nextTransition('none');
            if (!$ionicHistory.backView()) {
                $state.go('home');
            }
            ($ionicHistory.backView() && $ionicHistory.backView().url.indexOf('login') > 0) ? $ionicHistory.goBack(-2) : $ionicHistory.goBack();
        };
        if ($rootScope.addTravelNotesFlg) {
            $rootScope.addTravelNotesFlg = false;
        CustomBaseMainPlugin.pageJumpsNaviTableView(win, fail, [{skipPathType: 'addTravelNotes'}]);
        // @"addTravelNotes"   //添加游记
        }
        $timeout(function () {
            $rootScope.addTravelNotesFlg = true;
        }, 1000);
    };
        $rootScope.appChannel = function (type) {
            var win = function (r) {
            };
            var fail = function (e) {
            };
        if (window.cordova) {
            if (type == "exchangeRate") {
                PopupFactory.tipPopup("尚未开通，敬请期待！");
                return false;
            } else {
                CustomBaseMainPlugin.pageJumpsNaviTableView(win, fail, [{skipPathType: type}]);
                //@"userMessagePath" //我的消息标签   @"userMorePath"   //更多标签 @"travelNotesList"   //暂存游记列表
            }
        } else {
            PopupFactory.tipPopup("请下载国旅行在线APP进行爱旅行相关功能操作。");
        }
    };
    $rootScope.travelNotesListFlg = true;
    $rootScope.travelNotesList = function (type) {
        var win = function (r) {
            if (type == 'travelAround') {
                $state.reload();
            } else {
                $state.reload();
            }
        };
        var fail = function (e) {

        };
        if (window.cordova) {
            if ($rootScope.travelNotesListFlg) {
                $rootScope.travelNotesListFlg = false;
            CustomBaseMainPlugin.pageJumpsNaviTableView(win, fail, [{
                skipPathType: 'travelNotesList',
                travelNotesListType: type
            }]);
            }
            $timeout(function () {
                $rootScope.travelNotesListFlg = true;
            }, 1000);
            //@"travelNotes" //游记   @"travelAround"   //旅行圈
        } else {
            PopupFactory.tipPopup("请下载国旅行在线APP进行爱旅行相关功能操作。");
        }
    };
    $rootScope.travelNotesEditFlg = true;
    //修改游记
    $rootScope.appEditTrip = function (essayId, essayType) {
        var win = function (r) {
            if (essayType == 'YJ') {
                // 刷新页面
                $state.reload();
            } else {
                $state.reload();
            }
        };
        var fail = function (e) {
        };
        if ($rootScope.travelNotesEditFlg) {
            $rootScope.travelNotesEditFlg = false;
        CustomBaseMainPlugin.pageJumpsNaviTableView(win, fail, [{
            skipPathType: 'travelNotesEdit',
            essayId: essayId,
            essayType: essayType
        }]);
        }
        $timeout(function () {
            $rootScope.travelNotesEditFlg = true;
        }, 1000);
    };
        $rootScope.quitApp = function (type) {
            var win = function (r) {
            };
            var fail = function (e) {
            };
            CustomBaseMainPlugin.quitApp(win, fail, []);
        };
        $rootScope.appShake = function () {
            var win = function (r) {
            };
            var fail = function (e) {
            };
        CustomBaseMainPlugin.pageJumpsNaviTableView(win, fail, [{skipPathType: 'shakePath'}]);

    };
                 $rootScope.resetMessageNumToApp = function (messageNum) {
                     var win = function (r) {
                     };
                     var fail = function (e) {
                     };
                     try {
                         CustomBaseMainPlugin.resetMessageNum(win, fail, [{allInfor: messageNum}]);
                     } catch (e) {
                     }
                 };
                 if (window.cordova && CommonFactory.getUserInfo() == null) {
                     try {
                         $rootScope.resetMessageNumToApp("0");
                     } catch (e) {
                     }
                 }
    $rootScope.payByWX = function (wxJson) {
        var win = function (r) {
            PopupFactory.tipPopup(r);
            $timeout(function () {
		if(wxJson.channel!=undefined&&wxJson.channel!=null&&wxJson.channel=='HC'){
                        $state.go('train_order_detail',{orderId: wxJson.orderId,payFlay:'1'});
                }else {
                     // 跳转成功页面
                     $state.go('pay_success');
		}
            }, 2000);
        };
        var fail = function (e) {
            PopupFactory.tipPopup(e);
            $timeout(function () {
                if (e != null && e.indexOf('取消') > 0) {
                    // 跳转失败页面
                    $state.go('member_index');
                } else {
                    // 跳转失败页面
                        $state.go('pay_error');
                    }
                }, 2000);
            };
            CustomMainDefrayPlugin.weiXinPayRequest(win, fail, wxJson);
        };

    $rootScope.payByAlipay = function (priceInfo) {
        var win = function (r) {
            $rootScope.$broadcast('loading:show');
            CommonFactory.aliPayRerifyReq('aliPayRerifyReq.init', {
                verifyStr: r
            });
        };
        var fail = function (e) {
            $state.go('pay_error');
        };
        CustomMainDefrayPlugin.aliPayRequest(win, fail, priceInfo);
    };

    // APP招行支付调起
    $rootScope.payByCMB = function(data){
        var win = function (r) {
        };
        var fail = function (e) {
            $state.go('pay_error');
        };
        CustomMainDefrayPlugin.CMBAppPayRequest(win, fail, [
            {
                jsonStr: JSON.stringify(data)
            }]);
    };

        $rootScope.appLogin = function () {
            var win = function (r) {
                if (r.resultStatus == 'succeed') {  //来判断是否正确
                    CITS.saveTraffic(r.showImage);
                }
            };
            var fail = function (e) {
            };

            CustomBaseMainPlugin.commuteUserInfo(win, fail, [{uesrRegisterName: CommonFactory.getUserInfo()}]);
        };
        $rootScope.appLogout = function () {
            var win = function (r) {

            };
            var fail = function (e) {
            };

            CustomBaseMainPlugin.commuteUserInfo(win, fail, [{}]);
        };
    //add by sunsh 20160523 发现页面调用原生方法
    $rootScope.pushDiscoverPages = function (pageFlag) {
        var win = function (r) {

        };
        var fail = function (e) {
        };
        CustomBaseMainPlugin.pushDiscoverPages(win, fail, [pageFlag]);
    };

    $rootScope.deviceWidth = document.body.clientWidth;
    $rootScope.deviceHeight = (document.body.clientHeight == 0 ? document.querySelector('.backdrop').clientHeight : document.body.clientHeight);
    if (!window.cordova) {
        $rootScope.deviceWidth = $rootScope.deviceWidth > 640 ? 640 : $rootScope.deviceWidth;
    }

    var str = window.location.href;
    var sub = ['/help/aptitudeNative','/member/privacyPolicyApp'];
                 var isNoShowTop = false;
    for (var i = 0; i < sub.length; i++) {
        if (str.substr(str.length - sub[i].length,sub[i].length) == sub[i]) {
            isNoShowTop = true;
            break;
        }
    }
        if (window.location.href.toString().indexOf("isApp=true")
            != -1) {
            isNoShowTop = true;
        }

        if (window.cordova || CITS.getChannelSource() == '11' || CITS.getChannelSource() == '23' || isNoShowTop) {
        } else {
            //设备的高度,用于显示页头
            viewHeight = $rootScope.deviceHeight;
            //显示页头
            // showShareDiv($rootScope.deviceHeight);
        }
                 //判断会员，若处于黑名单则跳转会员登陆页
                 $rootScope.isBlackList = function () {
                     // 查询当前用户是否为黑名单
                     var userInfo = CommonFactory.getUserInfo();
                     var loginId = userInfo.loginId;
                     $rootScope.$on('getTouristInfo.init', function () {
                         var onlineTouristVO = memberPresonalInfoFactory.getTouristInfoResult();
                         if (onlineTouristVO.black_flag == "1") {
                             PopupFactory.evaluatePopup(
                                 "抱歉，您已被加入黑名单，请与国旅客服联系，客服热线：4006008888");
                             CommonFactory.clearUser();
                             if (window.cordova) {
                                 $state.go('member_login');
                             } else {
                                 var reCode = CITS.Session.get(
                                     CITS.info.PERSON_USER_KEY) || "";
                                 var ua = navigator.userAgent.toLowerCase();
                                 if ((CITS.getChannelSource() == '11') || (ua.match(
                                         /MicroMessenger/i)
                                                                           == "micromessenger" && reCode != "")
                                     || $rootScope.accountType == "wxlet") {
                                     $state.go('member_login');
                                 } else {
                                     //$state.go('member_elogin');
                                     $state.go('member_login');
                                 }

                    }
                }
            });
            memberPresonalInfoFactory.getTouristInfo(loginId, "loginid");
        };

        //获取最近站点
        function getLocatinDomain(toState,params) {

            var stateArr = ['/home','/second/:channel','/route/search/:desturl','/search/:channel','/market/list/:id'];
            //标识是否是打开新页面
            var isNowPage = Session.get(ENV.IS_NOW_PAGE);
            Session.set(ENV.IS_NOW_PAGE,true);

            //判断是不是在stateArr路由数组内
            if(stateArr.indexOf(toState.url) > -1){
                if(isNowPage != null){
                    $rootScope.isChangeLocatin();//24点之前
                }else{
                    if (params.domain != null) {
                        HostFactory.setHostDomain(params.domain);
                        getLocationAndStorage(false);
                    }else{
                       getLocationAndStorage(true); 
                    }
                }
            }
        }

//监听路由事件
    $rootScope.$on('$stateChangeStart',
        function (event, toState, toParams, fromState, fromParams) {
                //设置站点
                var params = $location.search();
                
                //获取最近站点
                getLocatinDomain(toState,params);
            if (fromState != null && fromState != undefined && fromState.name == 'home') {
                $rootScope.$broadcast('home:hide');
            }

                if(toState.name == 'werror'){
                    $state.go("werror");
                }
            // 当前路由是跳转到下单页面的情况，则判断登录人是否是黑名单用户
            // 如果是黑名单  则清除登录记录，跳转到登录页面
            var state = $state.get(toState.name);
            if (state.requiredLogin && toState.name.indexOf('book') != -1
                && CommonFactory.isLogined()) {
                // 查询当前用户是否为黑名单
                $rootScope.isBlackList();
            }

            $rootScope.$broadcast('loading:hide');
            var biteReg = new RegExp("(^|&?)biteflag=([^&]*)(&|$)", "i");
            var reg = new RegExp("(^|&?)user=([^&]*)(&|$)", "i");
            var absUrl = $location.absUrl();
            var bite = absUrl.match(biteReg);
            if (bite != null) {
                var biteFlag = unescape(bite[2]);
                Session.set(ENV.BITE_FLAG_KEY, biteFlag);
            }

            var r = absUrl.match(reg);
            if (r != null) {
                var perUser = unescape(r[2]);
            }
            else {
                var perUser = null;
            }
						
			/*var loginReg = new RegExp("(^|&?)loginflag=([^&]*)(&|$)", "i");
            var lreg = new RegExp("(^|&?)user=([^&]*)(&|$)", "i");
            var labsUrl = $location.absUrl();
            var lbite = labsUrl.match(loginReg);
            if (lbite != null) {
                var lFlag = unescape(lbite[2]);
                Session.set(ENV.LOGIN_FLAG_KEY, lFlag);
            }

            var lr = absUrl.match(lreg);
            if (lr != null) {
                var perUser = unescape(r[2]);
            }
            else {
                var perUser = null;
            }*/
	    
	    //
            var unionPayStyle = document.getElementById("unionPayStyle");
            if (unionPayStyle != null && unionPayStyle != undefined) {
                unionPayStyle.remove();
            }
            if (toState.url.indexOf('/unionPay2015/') != -1) {
                var width = document.documentElement.clientWidth;
                var styleNode = document.createElement('style');
                styleNode.setAttribute("id", "unionPayStyle");
                styleNode.innerHTML = 'html{font-size: ' + width / 750 * 100
                    + 'px!important;}';
                document.head.appendChild(styleNode);
            }
                var params = $location.search();
                if (params.domain != null && params.domain != undefined
                    && params.domain != HostFactory.getHostDomain()) {

                    // //处理小程序跳转---start
                    // var domFlag = params.domain.split("?");
                    // if (domFlag.length > 1) {
                    //     params.domain = domFlag[0];
                    // }
                    // //处理小程序跳转---end
                    // if (HostFactory.getAllHostDomain() == null) {
                    //     CommonFactory.loadAllDomainInfo('all_domian.init');
                    //     PopupFactory.alertPopup('站点切换', '您当前站点已经发生切换！');
                    // } else {
                    //     var domain_new = HostFactory.getSiteName(params.domain);
                    //     var domain_old = HostFactory.getSiteName(HostFactory.getHostDomain()) || '';
                    //     if (domain_old == '') {
                    //         domain_old = '北京';
                    //     }
                    //     if (domain_new != domain_old) {
                    //         PopupFactory.alertPopup('站点切换',
                    //             '您当前站点已经从' + domain_old + '站切换到' + domain_new
                    //             + '站！');
                    //     }
                    // }
                    event.preventDefault();
                    $ionicHistory.clearCache().then(function () {
                        HostFactory.setHostDomain(params.domain);
                        if (toState.name == 'home_user') {
                            $state.go('home');//设置路由地址
                        } else {
                            $state.go(toState.name, toParams);
                        }
                    });
                }
                if (perUser != null && perUser != undefined && perUser != '' && perUser != HostFactory.getPersonShopUser()) {
                    event.preventDefault();
                    //特殊权限处理
                    HostFactory.setHostDomain('www.ourtour.com');
                    $ionicHistory.clearCache().then(function () {
                        HostFactory.setPersonShopUser(perUser);
                        var promise = CommonFactory.qloadPersonShopInfo(); // 同步调用，获得承诺接口
                        promise.then(function (data) {  // 调用承诺API获取数据 .resolve
                            if (toState.name == 'home') {
                                $state.go('home_user');//设置路由地址
                            } else {
                                $state.go(toState.name, toParams);
                            }
                        }, function (data) {  // 处理错误 .reject
                        });
                    });

                }

            if ((params.user_phone || '') != '' && toState.name == 'home_user' && (toParams.user_phone || '') == '') {
                toParams.user_phone = params.user_phone;
            }
            if ((params.shareUrlParams || '') != '') {
                var queryData = angular.fromJson(params.shareUrlParams);
                params.shareUrlParams = '';
                // 国内机票
                if (queryData.state == "flight_gn_query") {
                    Session.set(ENV.FLIGHT_GN_RESULT_KEY, queryData);
                    $state.go(queryData.state, {queryData: queryData});
                }
                // 国际机票
                if (queryData.state == "flight_gj_first") {
                    Session.set(ENV.FLIGHT_GJ_FIRST_KEY, queryData);
                    $state.go(queryData.state, {queryData: queryData});
                }
            }

            if (params.miniProgramFlag != null && params.miniProgramFlag
                != undefined
                && params.miniProgramFlag == '1') {
                $state.go("pay_success",
                    {orderId: params.orderId, channel: params.channel});
            }

            if (toState.name == 'home_user' && HostFactory.getPersonShopUser() == null) {
                $location.path('/home');//设置路由地址
            }
            //如果目标页面需要用户登录，而当前尚未登录，则自动重定向到登录界面
            //判断toParams是否为空
            var isEmpty = true;
            for (var n in toParams) {
                isEmpty = false
            }
            //为空则将toParams由{}改为‘’,否则获取到的是[object object]，在手机上无法跳转
            toParams = isEmpty ? '' : toParams;
            var state = $state.get(toState.name);
            if (!window.cordova && (CITS.getChannelSource() == '11')) {
				Session.set('zdstate', 2);
               
               }
            var loginsources = '';
            var mobile = '';//b2b链接传过来的手机号码
            if(absUrl.trim().indexOf('?loginsources=')!=-1){
                var loginsourcesLs = absUrl.split("?");
                if ((loginsourcesLs || '') != '' && loginsourcesLs.length == 2) {
                    if((loginsourcesLs[1] || '') !=''){
                        var loginsourcesLsand = loginsourcesLs[1].split("&")[0];
                        if(loginsourcesLsand.split("=")[0] == 'loginsources'){
                            loginsources =  loginsourcesLsand.split("=")[1];
                        }

                        var mobileLs = loginsourcesLs[1].split("&")[1];
                        if(mobileLs.split("=")[0] == 'mobile'){
                            mobile = mobileLs.split("=")[1];
                        }
                    }
                }
            }

            //银联处理
            if (toState.name == 'unionPay_collectInfo' && !CommonFactory.isLogined()) {
                HostFactory.setEloginParams({'last':toState.name,'params':toParams,'loginsources':loginsources,'mobile':mobile});
            }

            if (state.requiredLogin && !CommonFactory.isLogined()
            ) {
                event.preventDefault();
                /* 跳转到登录前，清空个人信息 */
                CommonFactory.clearUser();
                /*JSON参数以字符串格式传递--------------------------*/

                if(loginsources == ''){
                   if(toState.name.indexOf('book')!=-1){
                       //预订页面
                       loginsources = 9;
                   }else{
                       if(toState.name == 'kefu_home' || toState.name == 'kefu_home'){
                           //客服
                           loginsources = 10;
                       }else if(toState.name == 'member_teamMeetInfo'){
                           //行前说明会
                           loginsources = 15;
                       }else if(toState.name == 'member_plan_add'){
                           //私人订制
                           loginsources = 12;
                       }else if(toState.name == 'member_teamOffInfo'){
                           //出团通知
                           loginsources = 14;
                       }else if(toState.name == 'travel_add' || toState.name == 'travel_circle_mine' || toState.name == 'travel_note_mine'
                                || toState.name == 'LXQDel' || toState.name == 'YJDel' || toState.name == 'travel_circle_index_tologin'
                                || toState.name == 'travel_circle_list_tologin'){
                           //爱旅行
                           loginsources = 16;
                       }else{
                           //其他
                           loginsources = 13;
                       }

                   }

                }
                HostFactory.setEloginParams({'last':toState.name,'params':toParams,'loginsources':loginsources,'mobile':mobile});

                if(window.cordova){
                    $state.go('member_login');
                }else{
                    var reCode = CITS.Session.get(CITS.info.PERSON_USER_KEY) || "";
                    var ua = navigator.userAgent.toLowerCase();
                    if ((CITS.getChannelSource() == '11') || (ua.match(/MicroMessenger/i)
                                                              == "micromessenger" && reCode != "")
                        || $rootScope.accountType == "wxlet") {
                        $state.go('member_login');
                    }else{
                        //$state.go('member_elogin');
                        $state.go('member_login');
                    }

                }

            }else if(state.requiredLogin && CommonFactory.isLogined()){
                if(mobile !=''){
                    var loginUserInfo = CommonFactory.getUserInfo();
                    var loginMobile = loginUserInfo.mobile;
                    if((loginMobile || '')!='' && loginMobile!=mobile){
                        $state.go('member_index');
                    }
                }
            }
            //网络推广来源
            var sourceflagReg = new RegExp("(^|&?)sourceflag=([^&]*)(&|$)", "i");
            var sourceflagLs = absUrl.match(sourceflagReg);
            if ((sourceflagLs || '') != '') {
                var sourceflag = sourceflagLs[2];
                if ((sourceflag || '') != '' && sourceflag != HostFactory.getSourceFlag()) {
                    $ionicHistory.clearCache(ENV.SOURCE_FLAG_KEY).then(
                        function () {
                        HostFactory.setSourceFlag(sourceflag);
                    });
                }
            }

            //值得买feedback值
            var feedbackReg = new RegExp("(^|&?)feedback=([^&]*)(&|$)", "i");
            var feedbackLs = absUrl.match(feedbackReg);
            if ((feedbackLs || '') != '') {
                var feedback = feedbackLs[2];
                if ((feedback || '') != '' && feedback != HostFactory.getFeedback()) {
                    $ionicHistory.clearCache('FEEDBACK_KEY').then(function () {
                        HostFactory.setFeedback(feedback);
                    });
                }
                if ((feedback || '') != '') {
                    $ionicHistory.clearCache(ENV.SOURCE_FLAG_KEY).then(
                        function () {
                            HostFactory.setSourceFlag("zdzdm");
                        });
                }
            }
            //什么值得买to值
            var toReg = new RegExp("(^|&?)to=([^&]*)(&|$)", "i");
            var toLs = absUrl.match(toReg);
            if ((toLs || '') != '') {
                var to = toLs[2];
                if((to || '') != ''){
                    window.location.href = decodeURIComponent(to);
                }

            }


        });
    // 微信分享手机网站的微信或者微店
    $rootScope.weiXinShare = function (title, imgUrl, description, stateName) {
        if (!window.cordova && (CITS.getChannelSource() == '11' || CITS.getChannelSource() == '13')) {
            CommonFactory.loadWeiXinService('', title, imgUrl, description, stateName);
        }
    };
    // 手机网站的微信或者微店
    if (!window.cordova && (CITS.getChannelSource() == '11' || CITS.getChannelSource() == '13')) {
        $rootScope.$on('$stateChangeSuccess',
            function (event, toState, toParams, fromState, fromParams) {
                CommonFactory.loadWeiXinService('', '', '', '', toState.name);
            });
    }
    // app分享
    $rootScope.appShare = function (title, imgUrl, description, index,
        shareUrlParams) {
        if (window.cordova) {
            var thisLink = ENV.SHARE_FILE_URL + $location.path();
            if (thisLink.indexOf("/route/search/") > 0
                || thisLink.indexOf("/home") > 0
                || thisLink.indexOf("/market/list/") > 0) {
                // 大搜页面和首页需要添加域名
                thisLink += '?domain=' + HostFactory.getHostDomain();
            }

            if (thisLink.indexOf("/route/search/") > 0
                || thisLink.indexOf("/detail") > 0) {
                var size = "_600x338";
                imgUrl =
                    imgUrl.replace('_600x450', '').replace('_200x150', '')
                        .replace(/\.jpg$|\.jpeg$|\.bmp$|\.gif$|\.png$/gi, '').replace('./', '')
                    + size + '.jpg';
            }

            // APP分享需求，要求会员聚合页落地页为首页
            if (thisLink.indexOf("/member/registactivity") > 0) {
                thisLink = ENV.SHARE_FILE_URL + "/home?domain="
                    + HostFactory.getHostDomain();
            }

            var perShopInfo = Session.get(ENV.PERSON_PHONE_KEY);
            if (perShopInfo != null) {
                // 微店需要添加店主
                if (thisLink.indexOf('?domain=') > 0) {
                    thisLink += '&user=' + perShopInfo.account;
                } else {
                    thisLink += '?user=' + perShopInfo.account;
                }
            }

            // 分享参数
            if (shareUrlParams != null && thisLink.indexOf('shareUrlParams=') < 0) {
                if (thisLink.indexOf('?domain=') > 0) {
                    thisLink += '&shareUrlParams=' + angular.toJson(
                            shareUrlParams);
                } else {
                    thisLink += '?shareUrlParams=' + angular.toJson(
                            shareUrlParams);
                }

                var queryData = angular.fromJson(shareUrlParams);
                // 抽奖
                if (queryData.state == "draw_index") {
                    if (queryData.location == "01"
                        || queryData.location == "05") { // 下单 评论
                        thisLink = ENV.SHARE_FILE_URL + "/team/detail/"
                            + queryData.routeId;
                    } else if (queryData.location == "04") { // 注册
                        thisLink = ENV.SHARE_FILE_URL + "/home?domain="
                            + HostFactory.getHostDomain();
                    }
                } else {
                    thisLink = thisLink.replace("#","?#");
                }
            }
            thisLink = encodeURI(thisLink);

            var thisImgUrl = imgUrl;
            if (!thisImgUrl) {
                if (perShopInfo) {
                    thisImgUrl = ENV.imgUrl + perShopInfo.icon;
                } else {
                    thisImgUrl = ENV.imgUrl + 'images/b2c/logo_1.png';
                }
            } else if (thisImgUrl.indexOf("http://file") < 0) {
                thisImgUrl = ENV.imgUrl + thisImgUrl;
            }

            var shareType = [];
            shareType[0] = 'SSDKPlatformSubTypeWechatSession';  // 微信好友
            shareType[1] = 'SSDKPlatformSubTypeWechatTimeline';  // 微信朋友圈
            shareType[2] = 'SSDKPlatformTypeSinaWeibo';   // 新浪微博
            shareType[3] = 'SSDKPlatformSubTypeQQFriend';   // QQ好友
            shareType[4] = 'SSDKPlatformSubTypeQZone';    // QQ空间
            CustomBaseMainPlugin.shareContentPassPlugin(function (str) {
                // 广播
                $rootScope.$broadcast('closeShare.init');
                if ((str || '').length > 0) {
                    PopupFactory.tipPopup(str);
                }
            }, function (str) {
                $rootScope.$broadcast('closeShare.init');
                if (str)PopupFactory.tipPopup(str);
            }, [description, thisImgUrl, thisLink, title, shareType[index]]);
        }
    };
    //登录信息收集
    $rootScope.addLoginInfoTrack = function (param) {
        LoginInfoTrackFactory.addLoginInfoTrack(param);
    };
        //切换站点domain.host_name  domain.site_name
        $rootScope.swich = function (host_name) {
            $ionicHistory.clearCache().then(function () {
                HostFactory.setHostDomain(host_name);
                // location.reload($location.path());
                // console.log('跳转');console.log('===');
                // HostFactory.setHostDomain('cs.ourtour.com');
                CommonFactory.loadDomainInfo('headerHost.init');
                $rootScope.$broadcast('reloadLocation');
            });
        };
       

        $rootScope.$on('getAllDomainInfo', function (event,isShowAlert) {
            //全部站点
            var AllDomain = CommonFactory.getAllDisorderlyDomainInfo();
            if (AllDomain == "") {
                console.log('没做站点信息');
                return;
            }
//上次缓存站点
            var storeDomain = HostFactory.getHostDomain();
//上次缓存站点详细信息
            var hostDomain = CommonFactory.getDomainInfoByLocation();
//当前定位
            var cunrenlocation = Session.get(ENV.LOCATION_KEY).position;
            var cunrenDomain   = {};
            var distance = 0;

            for (var i = 0; i < AllDomain.length; i++) {
                var local = AllDomain[i].domain_locate;
                if (undefined != local && 'undefined' != local) {
                    var arr   = local.split('|');
                    var cunrendistance = $rootScope.getStoreDistance(cunrenlocation.lng,cunrenlocation.lat,arr[0],arr[1]);
                    if (distance > cunrendistance || i == 0) {
                        cunrenDomain = AllDomain[i];
                        distance = cunrendistance;
                    }
                    //补充站点详细信息
                    if (storeDomain !=null && hostDomain==null && AllDomain[i].host_name == storeDomain) {
                        hostDomain = AllDomain[i];
                        CommonFactory.setDomainInfoByLocation(cunrenDomain);
                    }
               }
            }
            if (false == cunrenDomain.hasOwnProperty('domain_locate')) {
                console.log('没有经纬度字段');
                return;
            }
            if (cunrenDomain) {
                HostFactory.setNearlyHostDomain(cunrenDomain);
            }
            
            if (hostDomain == null) {
                if (cunrenDomain.host_name == 'www.ourtour.com') {
                    HostFactory.setHostDomain(cunrenDomain.host_name);
                    CommonFactory.setDomainInfoByLocation(cunrenDomain);
                    return; 
                }
            }
            if (cunrenDomain.host_name != storeDomain) {
                $rootScope.cunrenDomain = cunrenDomain;
                var loaction = Session.get(ENV.LOCATION_KEY).addressComponent.city == "" ? Session.get(ENV.LOCATION_KEY).addressComponent.province : Session.get(ENV.LOCATION_KEY).addressComponent.city;
                if (isShowAlert) {
                    if ($rootScope.priceDescriptionModal) {
                        $rootScope.priceDescriptionModal.show();
                    }else{
                        $rootScope.locationShowInfo = {};
                        $rootScope.locationShowInfo.info =  loaction ;
                        $rootScope.locationShowInfo.titles= cunrenDomain.site_name;
                        $ionicModal.fromTemplateUrl("templates/home/locationDescription.htm", {
                            scope: $rootScope,
                            animation: "slide-in-left"
                        }).then(function (modal) {
                            $rootScope.priceDescriptionModal = modal;
                            $rootScope.priceDescriptionModal.show();

                        }); 
                    }
                }
                
            }
        });
        //存储站点信息并切换站点
        $rootScope.saveDomain = function () {
            if ($rootScope.priceDescriptionModal) {
                $rootScope.priceDescriptionModal.hide();
            }
            CommonFactory.setDomainInfoByLocation($rootScope.cunrenDomain);
            $rootScope.swich($rootScope.cunrenDomain.host_name);
        };
        $rootScope.getDomainByLocationAndCompare = function (isShowAlert) {

            //加载所有站点
            CommonFactory.loadAllDomainInfo('getAllDomainInfo',isShowAlert);
        };
                 $rootScope.positionData = {
                     addressComponent: {
                         province: "北京市",
                         city: "北京市",
                         adcode: "110100"
                     },
                     position: {
                         lng: "116.41701033774925",
                         lat: "39.91509674974035"
                     },
                     auth: false
                 };
        //判断是否是当天
        function isToday(date) {
            //Code goes here.
            var d = new Date(date.toString().replace(/-/g, "/"));
            var todaysDate = new Date();
            if (d.setHours(0, 0, 0, 0) == todaysDate.setHours(0, 0, 0, 0)) {
                return true;
            } else {
                return false;
            }
        }

        //获取系统当前时间
        $rootScope.getThisDayTime = function () {
            var date = new Date();

            var year = date.getFullYear();        //年 ,从 Date 对象以四位数字返回年份
            var month = date.getMonth() + 1;      //月 ,从 Date 对象返回月份 (0 ~ 11) ,date.getMonth()比实际月份少 1 个月
            var day = date.getDate();             //日 ,从 Date 对象返回一个月中的某一天 (1 ~ 31)

            var hours = date.getHours();          //小时 ,返回 Date 对象的小时 (0 ~ 23)
            var minutes = date.getMinutes();      //分钟 ,返回 Date 对象的分钟 (0 ~ 59)
            var seconds = date.getSeconds();      //秒 ,返回 Date 对象的秒数 (0 ~ 59)

            //修改月份格式
            if (month >= 1 && month <= 9) {
                month = "0" + month;
            }

            //修改日期格式
            if (day >= 0 && day <= 9) {
                day = "0" + day;
            }

            //获取当前系统时间  格式(yyyy-mm-dd hh:mm:ss)
            var currentFormatDate = year + "-" + month + "-" + day;
            return currentFormatDate;
        };

        //定位方法
        $rootScope.getGeoLocation = function (isShowAlert) {
            if (window.cordova) {
                nativeApiLocation(isShowAlert);
            } else {
                jsApiLocation(isShowAlert);
            }
        };
        //原生定位
        function nativeApiLocation(isShowAlert) {
            console.log("原生定位开始:" + new Date());
            var win = function (data) {
                console.log("原生定位成功:" + new Date());
                $rootScope.positionData = {
                    addressComponent: {
                        province: data.province,
                        city: data.city,
                        adcode: data.adcode
                    },
                    position: {
                        lng: data.longitude,
                        lat: data.latitude
                    },
                    formattedAddress:data.formattedAddress,
                    auth: true
                };
                Session.set(ENV.LOCATION_KEY, $rootScope.positionData);
                Session.set(ENV.LOCATION_TIME, $rootScope.positionData);

                $rootScope.getDomainByLocationAndCompare(isShowAlert);
                    
            };
            var fail = function (data) {
                jsApiLocation(isShowAlert);
            };

            // $ionicPlatform.ready(function () {
                try {
                     customLocationPlugin.ResendGetLocation(win, fail, [{}]);
                } catch (e) {
                    jsApiLocation();
                }
            // });
        }
        //用高德js定位
        function jsApiLocation(isShowAlert){
            console.log("js api定位开始:" + new Date());
            //存放初始化的地图对象
            $rootScope.map = new AMap.Map("container", {
                resizeEnable: true,
                zoom: 14,
                zoomEnable: false,
                dragEnable: false
            });
            //初始化地理编码与逆地理编码类，用于地址描述与坐标之间的转换
            $rootScope.map.plugin(['AMap.Geolocation', 'AMap.Geocoder'], function () {
                var geolocation = new AMap.Geolocation({
                    enableHighAccuracy: true,//是否使用高精度定位，默认:true
                    timeout: 3000, //超过10秒后停止定位，默认：无穷大
                    maximumAge: 0, //定位结果缓存0毫秒，默认：0
                    convert: true, //自动偏移坐标，偏移后的坐标为高德坐标，默认：true
                    showButton: true, //显示定位按钮，默认：true
                    buttonPosition: 'LB', //定位按钮停靠位置，默认：'LB'，左下角
                    buttonOffset: new AMap.Pixel(10, 20), //定位按钮与设置的停靠位置的偏移量，默认：Pixel(10,
                                                          // 20)
                    showMarker: true, //定位成功后在定位到的位置显示点标记，默认：true
                    showCircle: true, //定位成功后用圆圈表示定位精度范围，默认：true
                    panToLocation: true, //定位成功后将定位到的位置作为地图中心点，默认：true
                    zoomToAccuracy: true, //定位成功后调整地图视野范围使定位位置及精度范围视野内可见，默认：false
                    bubble: true
                });
                $rootScope.map.addControl(geolocation);
                geolocation.getCurrentPosition();

                             //编码执行成功执行此事件，返回定位信息
                             AMap.event.addListener(geolocation, 'complete', onComplete);
                             //编码执行失败执行此事件，返回定位出错信息
                             AMap.event.addListener(geolocation, 'error', onError);

                // 解析定位结果
                function onComplete(data) {
                    console.log("js api定位成功:" + new Date());
                    data.auth = true;
                    Session.set(ENV.LOCATION_KEY, data);
                    var loc = data.addressComponent;
                    $rootScope.getDomainByLocationAndCompare(isShowAlert);

                    
                }

                //解析定位错误信息
                function onError(data) {

                    console.log("js api定位失败:" + new Date());
                    //定位失败，若session无位置信息则定位国旅，否则使用上一次session定位
                    if (Session.get(ENV.LOCATION_KEY)) {
                        var location = Session.get(ENV.LOCATION_KEY);
                        location.auth = false;
                        Session.set(ENV.LOCATION_KEY, location);
                    } else {
                        $rootScope.positionData.auth = false;
                        Session.set(ENV.LOCATION_KEY, $rootScope.positionData);
                    }
                    if (data && data.info && data.message) {
                        console.info("定位失败info：" + data.info + ";message：" + data.message);
                    }
                }
            });
        }
        $rootScope.isChangeLocatin = function () {

            if (Storage.get('location_time') == null
                || !isToday(Storage.get('location_time'))
                || !Session.get(ENV.LOCATION_KEY)) {
                getLocationAndStorage(true);
            }
        };

        function getLocationAndStorage(isShowAlert) {
            Storage.set('location_time', $rootScope.getThisDayTime());
            //初始化执行
            $rootScope.getGeoLocation(isShowAlert);
        }

                 //计算经纬度距离差
                 $rootScope.getStoreDistance = function (currentLng, currentLat, storeLng, storeLat) {
                     var radLat1 = (currentLat * Math.PI / 180.0);
                     var radLat2 = (storeLat * Math.PI / 180.0);
                     var a = radLat1 - radLat2;
                     var b = (currentLng - storeLng) * Math.PI / 180.0;
                     var s = 2 * Math.asin(
                         Math.sqrt(Math.pow(Math.sin(a / 2), 2) + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)));
                     s = s * 6378137.0;    //单位M(EARTH_RADIUS )
                     s = Math.round(s * 10000) / 10000;
                     return s;
                 };

                 //百度坐标转高德坐标（火星坐标）
                 $rootScope.bdToGaoDe = function (bd_lat, bd_lon) {
                     var PI = Math.PI * 3000.0 / 180.0;
                     var x = bd_lon - 0.0065;
                     var y = bd_lat - 0.006;
                     var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * PI);
                     var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * PI);

                     return z * Math.cos(theta) + "|" + z * Math.sin(theta);
                 };
}]);


citsApp.config(['$stateProvider', '$urlRouterProvider', '$ionicConfigProvider', '$httpProvider', '$sceDelegateProvider', function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $httpProvider, $sceDelegateProvider) {
    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('standard');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('left');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');

    if (!window.cordova) {
        $ionicConfigProvider.views.transition('none');
    }

    /*A前进页面不缓存，全部重新加载----------------------------------------------*/
    $ionicConfigProvider.views.forwardCache(false);

    // ios禁用侧滑返回
    $ionicConfigProvider.views.swipeBackEnabled(false);

    /* 为了解决键盘弹出屏幕折叠问题，android:windowSoftInputMode=adjustPan 依赖  */
    ionic.Platform.isFullScreen = false;

        $stateProvider
            .state('home_new', {
                url: '/test/home/new',
                //cache: false,
                templateUrl: 'templates/home/home.htm',
                controller: 'HomeCtrl',
                params: {cache: ''}
            })
            .state('home', {
                url: '/home',
                //cache: false,
                templateUrl: 'templates/home/homeNew.htm',
                controller: 'HomeNewCtrl',
                params: {cache: ''}
            })
            .state('home_user', {
                url: '/person',
                params: {user_phone: ''},
                templateUrl: 'templates/home/homeUser.htm',
                controller: 'HomeUserCtrl'
            })
            //系统出错页面
            .state('error', {
                url: '/error',
                templateUrl: 'templates/common/error.htm',
                controller: 'ErrorCtrl'
            })
            //系统出错页面
            .state('werror', {
                url: '/werror',
                templateUrl: 'templates/common/werror.htm',
                controller: 'ErrorCtrl'
            })
            //系统出错页面
            .state('auth', {
                url: '/auth',
                templateUrl: 'templates/common/auth.htm',
                controller: 'ErrorCtrl'
            })
            .state('net', {
                url: '/net',
                templateUrl: 'templates/common/net.htm',
                controller: 'ErrorCtrl'
            })
            .state('404', {
                url: '/404',
                templateUrl: 'templates/common/404.htm',
                controller: 'ErrorCtrl'
            })
            //全文检索页面
            .state('all_searchDest', {
                url: '/search/:channel',
                cache: false,
                templateUrl: "templates/home/homeSearch.htm",
                controller: 'HomeSearchCtrl'
            })
            //站点选择页面
            .state('domain_select', {
                url: '/domain',
                cache: false,
                templateUrl: "templates/home/domainSelect.htm",
                controller: 'DomainSelectCtrl'
            })
            //聚合页面
            .state('route_search', {
                url: '/route/search/:desturl',
                // cache: false,
                templateUrl: "templates/search/routeSearch.htm",
                controller: 'SearchCtrl'
            })

        //聚合页面
        .state('ticket_search', {
            url: '/ticket/search/:desturl',
            //cache: false,
            templateUrl: "templates/search/ticketSearch.htm",
            controller: 'TicketCtrl'
        })
        //聚合页面
        .state('visa_search', {
            url: '/visa/search/:desturl',
            // cache: false,
            templateUrl: "templates/search/visaSearch.htm",
            controller: 'VisaCtrl'
        })
        //订单预订失败页面
        .state('bookError', {
            url: 'shop/book/bookError',
            templateUrl: "templates/common/bookError.htm",
            params: {resultData: '@resultData'},
            controller: 'BookResultCtrl'
        })
        //订单预订成功页面
        .state('bookSucc', {
            url: 'shop/book/bookSucc',
            cache: false,
            templateUrl: "templates/common/bookSucc.htm",
            params: {resultData: '@resultData'},
            controller: 'BookResultCtrl'
        })

        //首页头条信息
    .state('news_headline', {
        url: '/news/headline',
        templateUrl: "templates/headline/newsHeadline.htm",
        controller: 'NewsHeadlineCtrl'
    })
    //头条详细信息
    .state('headline_detail', {
        url: '/headline/detail/:id',
        templateUrl: "templates/headline/headlineDetail.htm",
        controller: 'HeadlineDetailCtrl'
    })

    /*******************两游用start********************/
        //两游详细页(基础数据)
        .state('team_detail', {
            url: '/team/detail/:routeId',
            //cache: false,
            templateUrl: 'templates/team/routeDetail.htm',
            params: {'routeId': '@routeId', 'favoriteFlg': ''},
            controller: 'RouteDetailCtrl'
        })

        //温馨提示页
        .state('team_quote', {
            url: '/team/quote/:routeId',
            templateUrl: 'templates/team/quoteInfo.htm',
            controller: 'LargeTextCtrl'
        })

        //另付费项目说明页面
        .state('team_otherPaid', {
            url: '/team/otherpaid/:routeId',
            templateUrl: 'templates/team/otherPaid.htm',
            controller: 'LargeTextCtrl'
        })

        //购物说明页面
        .state('team_shopping', {
            url: '/team/shopping/:routeId',
            templateUrl: 'templates/team/shopping.htm',
            controller: 'LargeTextCtrl'
        })

        //签证信息页
        .state('team_visa', {
            url: '/team/visa/:routeId',
            templateUrl: 'templates/team/visa.htm',
            controller: 'LargeTextCtrl'
        })

        //温馨提示页
        .state('team_memo', {
            url: '/team/memo/:routeId',
            templateUrl: 'templates/team/memo.htm',
            controller: 'LargeTextCtrl'
        })

        //预订须知页
        .state('team_note', {
            url: '/team/note/:routeId',
            templateUrl: 'templates/team/note.htm',
            controller: 'LargeTextCtrl'
        })

        //安全须知页
        .state('team_safety', {
            url: '/team/safety/:routeId',
            templateUrl: 'templates/team/safetyNote.htm',
            controller: 'LargeTextCtrl'
        })

        //另付费项目详细页面
        .state('team_otherPaidDetail', {
            url: '/team/otherpaid/detail/:opId',
            templateUrl: 'templates/team/otherPaidDetail.htm',
            controller: 'LargeTextDetailCtrl'
        })

        //购物说明详细页面
        .state('team_otherShoppingDetail', {
            url: '/team/shopping/detail/:opId',
            templateUrl: 'templates/team/shoppingDetail.htm',
            controller: 'LargeTextDetailCtrl'
        })

        //签约付款页面
        .state('team_signingPayment', {
            url: '/team/payment/:routeId',
            templateUrl: 'templates/team/signingPayment.htm',
            controller: 'LargeTextCtrl'
        })

        //团详细页面
        .state('team_date', {
            url: '/team/date/:routeId',
            templateUrl: 'templates/team/teamDetail.htm',
            params: {'routeId': '@routeId'},
            cache: false,
            controller: 'TeamDetailCtrl'
        })

        //两游预订页面
        .state('team_book', {
            url: '/team/book/booking',
            templateUrl: 'templates/team/teamBooking.htm',
            params: {
                'loginJumpUrl': 'team_book',
                bookingData: '@bookingData',
                'orderInfo': '@orderInfo',
                'returnBackFlag': '@returnBackFlag'
            },
            controller: 'TeamBookCtrl',
            cache: false,
            requiredLogin: true
        })
        //二级首页
        .state('second_index', {
            url: '/second/:channel',
            templateUrl: 'templates/team/secondIndex.htm',
            params: {'channel': '@channel'},
            controller: 'TeamSecondIndexCtrl'
        })
    /*******************两游用end********************/

    /*******************邮轮start********************/
        //邮轮详细页(基础数据)
        .state('cruise_detail', {
            url: '/cruise/detail/:searchType/:routeId',
            templateUrl: 'templates/cruise/cruiseDetail.htm',
            params: {'searchType': '', 'routeId': '', 'favoriteFlg': ''},
            //cache: false,
            controller: 'CruiseDetailCtrl'
        })

        //邮轮船只详细信息
        .state('cruise_ship', {
            url: '/cruise/ship/:shipId',
            templateUrl: 'templates/cruise/cruiseShip.htm',
            //cache: false,
            controller: 'CruiseShipCtrl'
        })

        //邮轮公司详细信息
        .state('cruise_company', {
            url: '/cruise/company/:companyId',
            templateUrl: 'templates/cruise/cruiseCompany.htm',
            // cache: false,
            controller: 'CruiseCompanyCtrl'
        })

        //舱位详细信息页面
        .state('cruise_team', {
            url: '/cruise/team/:searchType/:routeId/:teamId/:cabinId',
            templateUrl: 'templates/cruise/cruiseTeam.htm',
            cache: false,
            params: {},
            controller: 'CruiseTeamCtrl'
        })

        //邮轮预订页面
        .state('cruise_book', {
            url: '/cruise/book/booking',
            templateUrl: 'templates/cruise/cruiseBooking.htm',
            cache: false,
            params: {bookingData: '@bookingData'},
            controller: 'CruiseBookCtrl',
            requiredLogin: true
        })

        //费用说明页面
        .state('cruise_quote', {
            url: '/cruise/quote/:routeId',
            templateUrl: 'templates/cruise/quoteInfo.htm',
            controller: 'CruiseTextCtrl'
        })

        //签证信息页
        .state('cruise_visa', {
            url: '/cruise/visa/:routeId',
            templateUrl: 'templates/cruise/visa.htm',
            controller: 'CruiseTextCtrl'
        })

        //温馨提示页
        .state('cruise_memo', {
            url: '/cruise/memo/:routeId',
            templateUrl: 'templates/cruise/memo.htm',
            controller: 'CruiseTextCtrl'
        })

        //预订须知页
        .state('cruise_note', {
            url: '/cruise/note/:routeId',
            templateUrl: 'templates/cruise/note.htm',
            controller: 'CruiseTextCtrl'
        })

        //签约付款页面
        .state('cruise_signingPayment', {
            url: '/cruise/payment/:routeId',
            templateUrl: 'templates/cruise/signingPayment.htm',
            controller: 'CruiseTextCtrl'
        })

        //安全须知页面
        .state('cruise_safetyNote', {
            url: '/cruise/safety/:routeId',
            templateUrl: 'templates/cruise/safetyNote.htm',
            controller: 'CruiseTextCtrl'
        })

    /*******************邮轮end********************/

    /*******************旅游类共同用start********************/
        //预订市场活动页面
        .state('coupon_market', {
            url: '/:channelFlg/book/market',
            templateUrl: 'templates/common/couponMarket.htm',
            cache: false,
            params: {param: '@param', channelFlg: '@channelFlg'},
            controller: 'CouponMarketCtrl'
        })
        //预订成功页面
        .state('travel_success', {
            url: '/:channelFlg/book/success',
            templateUrl: 'templates/common/travelSuccess.htm',
            cache: false,
            params: {orderParam: '@orderParam', channelFlg: '@channelFlg'},
            controller: 'CommonBookCtrl'
        })
        //预订支付成功页面
        .state('travel_pay_success', {
            url: '/book/pay/success',
            templateUrl: 'templates/common/travelPaySuccess.htm',
            cache: false,
            params: {orderParam: '@orderParam'},
            controller: 'CommonBookPayCtrl'
        })
        //预订成功失败页面
        .state('travel_fail', {
            url: '/:channelFlg/book/fail',
            templateUrl: 'templates/common/travelFail.htm',
            cache: false,
            params: {orderParam: '@orderParam', channelFlg: '@channelFlg'},
            controller: 'CommonBookCtrl'
        })
    /*******************旅游类共同用end********************/


        .state('visa_home', {
            url: '/visa/home',
            templateUrl: "templates/visa/visaHome.htm",
            controller: 'VisaHomeCtrl'
        })

        .state('visa_notice', {
            url: '/visa/notice',
            templateUrl: "templates/visa/visaNotice.htm",
        })

        .state('visa_process', {
            url: '/visa/process',
            templateUrl: "templates/visa/visaProcess.htm",
        })

        .state('visa_knowledge', {
            url: '/visa/knowledge',
            templateUrl: "templates/visa/visaKnowledge.htm",
        })

        .state('visa_detail', {
            url: '/visa/detail/:vid',
            cache: 'false',
            templateUrl: "templates/visa/visaDetail.htm",
            controller: 'VisaProdDetailCtrl'
        })

        .state('visa_material', {
            url: '/visa/material/:vid',
            cache: 'false',
            templateUrl: "templates/visa/visaMaterial.htm",
        })

        .state('visa_booking', {
            url: '/visa/booking',
            cache: 'false',
            params: {'loginJumpUrl': "visa_booking", 'bookingData': null, 'orderInfo': null},
            templateUrl: "templates/visa/visaBooking.htm",
            controller: 'VisaBookingCtrl',
            requiredLogin: true
        })

        .state('booking_success', {
            url: '/visa/booking/success',
            params: {'data': {}},
            cache: 'false',
            templateUrl: "templates/visa/bookingSuccess.htm",
            controller: 'BookingSuccCtrl'
        })
        .state('booking_failure', {
            url: '/visa/booking/fail',
            params: {'visaId': null},
            cache: 'false',
            templateUrl: "templates/visa/bookingFailure.htm",
            controller: 'BookingFailCtrl'
        })
    /******************* 会员中心 开始 ********************/
        .state('member_club', {
            url: '/member/memberClub',
            //cache: false,
            templateUrl: "templates/member/memberClub/member-club.htm",
            controller: 'MemberCtrl'
        })
        .state('member_constitution', {
            url: '/member/memberConstitution',
            //cache: false,
            templateUrl: "templates/member/memberClub/memberConstitution.htm",
            controller: 'MemberCtrl'
        })
        .state('contract_check', {
            url: '/member/contact',
            //cache: false,
            templateUrl: "templates/member/contractCheck.htm",
            controller: 'DiscoveryCtrl'
        })
        .state('discovery', {
            url: '/member/discovery',
            //cache: false,
            templateUrl: "templates/member/discovery.htm",
            controller: 'DiscoveryCtrl'
        })
        .state('member_index', {
            url: '/member/index',
            cache: false,
            templateUrl: "templates/member/index.htm",
            controller: 'MemberCtrl',
            requiredLogin: true
        })
        .state('commonly_info', {
            url: '/member/commonly',
            templateUrl: "templates/member/commonly/commonlyInfo.htm",
            controller: 'MemberCommonlyCtrl',
            requiredLogin: true
        })
        .state('integral_rule', {
            url: '/member/integralRule',
            cache: false,
            templateUrl: "templates/member/integralRule.htm",
            controller: 'MemberCtrl',
            requiredLogin: true
        })
        .state('member_privilege', {
            url: '/member/memberPrivilege',
            cache: false,
            templateUrl: "templates/member/memberPrivilege.htm"
        })
        .state('member_order', {
            url: '/member/order',
            params: {'data': null},// 如果页面有跳转，可以自定义参数
            cache: false,
            templateUrl: "templates/member/order/orderList.htm",
            controller: 'MemberOrderCtrl',
            requiredLogin: true
        })

        .state('order_detail', {
            url: '/order/detail/:orderId/:channel',
            cache: false,
            templateUrl: "templates/member/order/detail/orderDetail.htm",
            controller: 'MemberOrderDetailCtrl',
            requiredLogin: true
        })

        .state('order_contract_list', {
            url: '/contractlist/:orderId/:contractFlg',
            cache: false,
            templateUrl: "templates/member/order/contract/contractList.htm",
            controller: 'MemberContractListCtrl',
            requiredLogin: true
        })

        .state('order_contract', {
            url: '/contract/:orderId/:contract_no/:contractFlg',
            cache: false,
            templateUrl: "templates/member/order/contract/contractInfo.htm",
            controller: 'MemberContractCtrl',
            requiredLogin: true
        })

        .state('contract_sign', {
            url: '/sign/:loginId/:vid',
            cache: false,
            params: {loginId: null, vid: null},
            templateUrl: "templates/member/order/contract/contractSign.htm",
            controller: 'ContractSignCtrl',
            requiredLogin: true
        })

        .state('contract_see', {
            url: '/see/:contractId',
            cache: false,
            params: {contractId: null},
            templateUrl: "templates/member/order/contract/contractSee.htm",
            controller: 'ContractSeeCtrl',
            requiredLogin: true
        })

        .state('contract_succ', {
            url: '/contract/succ',
            params: {param: null},
            cache: false,
            templateUrl: "templates/member/order/contract/contractSucc.htm",
            controller: 'ContractSuccessCtrl',
            requiredLogin: true
        })

        .state('contract_fail', {
            url: '/contract/fail',
            templateUrl: "templates/member/order/contract/contractFail.htm"
        })

        .state('member_payment', {
            url: '/payChoice/:orderId/:channel',
            cache: false,
            templateUrl: "templates/member/payment/payChoice.htm",
            controller: 'MemberPayCtrl',
                requiredLogin: true
            })
            .state('starPay', {
                url: '/starPay/:redisKey',
                cache: false,
                templateUrl: "templates/member/payment/payLoading.htm",
                controller: 'StarPayInitCtrl',
            requiredLogin: true
        })

        .state('pay_success', {
            url: '/pay/success',
            cache: false,
            params: {orderId: null, channel: null},
            templateUrl: "templates/member/payment/paySuccess.htm",
            controller: 'PayResultCtrl'
        })

        .state('cmb_pay_notice', {
            url: '/cmb/pay/notice',
            cache: false,
            params: {orderId: null, channel: null, tradeNo: null},
            templateUrl: "templates/member/payment/payLoading.htm",
            controller: 'CmbPayResultCtrl'
        })

        .state('pay_error', {
            url: '/pay/error',
            cache: false,
            params: {errorMsg: null},
            templateUrl: "templates/member/payment/payError.htm",
            controller: 'PayResultCtrl'
        })

        .state('member_login', {
            url: '/member/login',
            cache: false,
            params: {last: null, params: null},
            templateUrl: "templates/member/login/login.htm",
            controller: 'MemberLoginCtrl'
        })
        .state('member_elogin', {
            url: '/member/elogin',
            cache: false,
            controller: 'MemberELoginCtrl'
        })
        .state('member_ereceive', {
            url: '/elogin/receiveLogin',
            cache: false,
            params: {param: '@param'},
            controller: 'MemberEReceiveCtrl'
        })
        .state('member_elogout', {
            url: '/member/elogout',
            cache: false,
            controller: 'MemberELogoutCtrl'
        })
        .state('member_eoutreceive', {
            url: '/elogout/receiveLogout',
            cache: false,
            controller: 'MemberEOutReceiveCtrl'
        })
        .state('user_activation', {
            url: '/user/activation',
            cache: false,
            params: {last: null, params: null, userName: null, token: null},
            templateUrl: "templates/member/login/memActivation.htm",
            controller: 'MemberActivationCtrl'
        })

        .state('member_register', {
            url: '/member/register',
            cache: false,
            params: {last: null, params: null, mobile: null},
            templateUrl: "templates/member/register/register.htm",
            controller: "RegisterCtrl"
        })
        .state('member_registactivity', {
            url: '/member/registactivity',
            cache: false,
            params: {last: null, params: null, mobile: null},
            templateUrl: "templates/member/register/registactivity.htm",
            controller: "RegistactivityCtrl"
        })
        .state('member_registerSucc', {
            url: '/member/registerSucc',
            cache: false,
            params: {showFlag: false, registerType: null, registerChannel: null},
            templateUrl: "templates/member/register/registerSucc.htm",
            controller: "RegisterSuccCtrl"
        })


        .state('member_resetPassword', {
            url: '/member/resetPswd',
            templateUrl: "templates/member/resetPswd/getBackPassword.htm",
            controller: 'ResetPasswordCtrl',
            cache: false
        })

        // 帮助与反馈
    .state('member_helpAndFeedback', {
        url: '/member/helpAndFeedback',
        templateUrl: "templates/member/helpAndFeedback/helpAndFeedback.htm",
        controller: 'HelpAndFeedbackCtrl',
        requiredLogin: true,
        cache: false
    })
    // 忘记密码如何找回
    .state('member_forgetPsd', {
        url: '/member/forgetPsd',
        templateUrl: "templates/member/helpAndFeedback/forgetPsd.htm",
    })
    // 旅游度假产品相关问题
    .state('member_holidayProduct', {
        url: '/member/holidayProduct',
        templateUrl: "templates/member/helpAndFeedback/holidayProduct.htm",
    })
    // 游轮产品相关问题
    .state('member_cruiseProduct', {
        url: '/member/cruiseProduct',
        templateUrl: "templates/member/helpAndFeedback/cruiseProduct.htm",
    })
    // 账户注销申请
    .state('member_accountCancellation', {
        url: '/member/accountCancellation',
        templateUrl: "templates/member/helpAndFeedback/accountCancellation.htm",
        controller: 'AccountCancellationCtrl',
        cache: false
    })
    // 旅游者投诉
    .state('member_touristComplaint', {
        url: '/member/touristComplaint',
        templateUrl: "templates/member/helpAndFeedback/touristComplaint.htm",
    })
    // 隐私政策
    .state('member_privacyPolicy', {
        url: '/member/privacyPolicy',
        templateUrl: "templates/member/helpAndFeedback/privacyPolicy.htm",
    })
    // 隐私政策App去页头定制页面
    .state('member_privacyPolicyApp', {
        url: '/member/privacyPolicyApp',
        templateUrl: "templates/member/helpAndFeedback/privacyPolicyApp.htm",
    })
    // 在线条款
        .state('member_onlineBooking', {
            url: '/member/onlineBooking',
            templateUrl: "templates/member/helpAndFeedback/onlineBooking.htm",
        })
    // 旅游者投诉
    .state('member_cancelTips', {
        url: '/member/cancelTips',
        templateUrl: "templates/member/helpAndFeedback/cancelTips.htm",
        controller: 'CancelTipsCtrl',
    })
    // 注销进度
    .state('member_cancelProgress', {
        url: '/member/cancelProgress',
        templateUrl: "templates/member/helpAndFeedback/cancelProgress.htm",
        controller: 'CancelProgressCtrl',
        params: {mobile: null},
        cache: false
    })

        // 修改积分使用密码
        .state('member_setIntPswd', {
            url: '/member/setIntPswd',
            templateUrl: "templates/member/resetPswd/setIntPswd.htm",
            controller: 'SetIntPswdCtrl',
            params: {stateName: null, param: '@param'},
            cache: false,
            requiredLogin: true
        })

        //配送地址
        .state('member-expression', {
            url: '/member/database/editExpression',
            params: {param: '@param'},
            templateUrl: "templates/member/database/expressionInfo.htm",
            controller: 'MemberExpressionCtrl',
            cache: false,
            requiredLogin: true
        })
        .state('member_messageList', {
            url: '/member/message/list',
            //cache: false,// 解决从公告详细页回到列表页页面重新加载的问题
            templateUrl: "templates/member/message/messageList.htm",
            params: {messageType: '@param'},
            controller: 'MemberMessagesCtrl',
            requiredLogin: true
        })
        .state('member_messageDetail', {
            url: '/member/message/detail/:id',
            cache: false,
            params: {id: '@id', param: '@param'},
            templateUrl: "templates/member/message/messageDetail.htm",
            controller: 'MessageDetailCtrl',
            requiredLogin: true
        })
        .state('member_newsNoti', {
            url: '/member/news/list',
            //cache: false,// 解决从公告详细页回到列表页页面重新加载的问题
            templateUrl: "templates/member/news/newsNotice.htm",
            controller: 'MemberNewsNotiCtrl',
            requiredLogin: true
        })
        .state('member_newsDetail', {
            url: '/member/news/detail/:news_id',
            cache: false,
            params: {news_id: '@param'},
            templateUrl: "templates/member/news/newsDetail.htm",
            controller: 'MemberNewsDetailCtrl',
            requiredLogin: true
        })
        // 私人订制
        .state('member_plan_add', {
            url: '/member/plan/add',
            params: {param: '@param'},
            templateUrl: "templates/member/plan/tourPlanAdd.htm",
            cache: false,
            controller: 'MemberPlanAddCtrl',
            requiredLogin: true
        })
        .state('member_plan_success', {
            url: '/member/plan/success',
            params: {param: '@param'},
            templateUrl: "templates/member/plan/tourPlanSuccess.htm",
            cache: false,
            controller: 'MemberPlanSuccessCtrl',
            requiredLogin: true
        })
        // 私人订制
        .state('member_plan_list', {
            url: '/member/plan/list',
            params: {param: '@param'},
            cache: false,
            templateUrl: "templates/member/plan/tourPlanList.htm",
            controller: 'MemberPlanListCtrl',
            requiredLogin: true
        })
        // 常用地址列表页面
        .state('member-address', {
            url: '/member/address/addressListInfo',
            params: {param: '@param'},
            templateUrl: "templates/member/address/addressListInfo.htm",
            controller: 'AddressListCtrl'
        })
        // 常用旅客信息列表页面
        .state('member-traver', {
            url: '/member/traver/traverListInfo',
            params: {param: '@param'},
            templateUrl: "templates/member/traver/traverListInfo.htm",
            cache: false,
            controller: 'TraverListCtrl'
        })
        // 优惠券信息列表
        .state('member_coupon', {
            url: '/member/coupon/list',
            templateUrl: "templates/member/coupon/couponList.htm",
            cache: false,
            controller: 'CouponListCtrl',
            requiredLogin: true
        })
        // 优惠券激活页面
        .state('member_activation', {
            url: '/member/coupon/activation',
            templateUrl: "templates/member/coupon/activation.htm",
            params: {codeNo: ''},
            cache: false,
            controller: 'CouponActivCtrl',
            requiredLogin: true
        })

        //我的出团通知
        .state('member_teamOffInfo', {
            url: '/member/tours/teamOffInfo',
            templateUrl: "templates/member/tours/teamOffInfo.htm",
            controller: 'MemberteamOffInfoCtrl',
            requiredLogin: true
        })
        //我的出团通知详细
        .state('member_teamOffDet', {
            url: '/member/tours/teamOffDet',
            templateUrl: "templates/member/tours/teamOffDet.htm",
            params: {params: '@params'},
            controller: 'MemberteamOffDetCtrl',
            requiredLogin: true
        })
        //我的行前说明会
        .state('member_teamMeetInfo', {
            url: '/member/tours/teamMeetInfo',
            templateUrl: "templates/member/tours/teamMeetInfo.htm",
            controller: 'MemberteamMeetInfoCtrl',
            requiredLogin: true
        })
        //个人设置
        .state('member_presonalInfo', {
            url: '/member/personalinfomodify/presonalInfo',
            templateUrl: "templates/member/personalinfomodify/presonalInfo.htm",
            controller: 'memberPersonalInfoCtrl',
            requiredLogin: true,
            cache: false
        })
            //生成发票
            .state('member_invoice', {
                url: '/member/invoice',
                templateUrl: "templates/member/invoice/createInvoice.htm",
                controller: 'InvoiceCtrl',
                params: {param: null},
                requiredLogin: true,
                cache: false
            })
            //查看发票
            .state('see_invoice', {
                url: '/invoice/see/:orderId',
                templateUrl: "templates/member/invoice/seeInvoice.htm",
                controller: 'InvoiceSeeCtrl',
                params: {param: null},
                requiredLogin: true,
                cache: false
            })
            // //查看发票
            // .state('see_invoice', {
            //     url: '/invoice/see',
            //     templateUrl: "templates/member/invoice/seeInvoice.htm",
            //     controller: 'InvoiceSeeCtrl',
            //     params: {param: null},
            //     requiredLogin: true,
            //     cache: false
            // })
            //发票授权成功
            .state('ali_invoice_empower', {
                url: '/invoice/empowerSuccess',
                templateUrl: "templates/member/invoice/empowerSuccess.htm",
                controller: 'InvoiceEmpowerCtrl',
                cache: false
            })
            //发票取消授权
            .state('ali_invoice_revoke_empower', {
                url: '/invoice/revokeEmpower',
                templateUrl: "templates/member/invoice/revokeEmpower.htm",
                controller: 'InvoiceRevokeEmpowerCtrl',
                cache: false
            })
        // 我的收藏列表
        .state('member_favorite', {
            url: '/member/favorite/list',
            templateUrl: "templates/member/favorite/myFavorList.htm",
            cache: false,
            controller: 'myFavorListCtrl',
            requiredLogin: true
        })
        // 我的历史浏览列表
        .state('member_history', {
            url: '/member/history/list',
            templateUrl: "templates/member/history/myHistoryList.htm",
            cache: false,
            controller: 'myHistoryListCtrl',
            requiredLogin: true
        })
        //我的点评
        .state('member_comment', {
            url: '/member/comment/list',
            templateUrl: "templates/member/comment/myCommentList.htm",
            cache: false,
            controller:'myCommentListCtrl',
            requiredLogin: true
        })
        // 我的额度
        .state('member_myAccount', {
            url: '/member/myAccount',
            templateUrl: "templates/member/myAccount/myAccount.htm",
            params: {'data': null},
            cache: false,
            controller: 'myAccountCtrl',
            requiredLogin: true
        })
        // 我的积分
        .state('member_integral_list', {
            url: '/member/integral/list',
            templateUrl: "templates/member/integral/integralList.htm",
            controller: 'IntegralListCtrl',
            requiredLogin: true
        })
        // 我的积分支付
        .state('member_integral_pay', {
            url: '/pay/integral',
            templateUrl: "templates/member/integral/integralPay.htm",
            controller: 'IntegralPayCtrl',
            params: {param: '@param'},
            cache: false,
            requiredLogin: true
        })
        // 积分申请确认
        .state('member_integral_confirm', {
            url: '/member/integral/confirm',
            templateUrl: "templates/member/integral/integralConfirm.htm",
            controller: 'IntegralConfirmCtrl',
            params: {param: '@param'},
            cache: false,
            requiredLogin: true
        })
        // 我的积分支付成功
        .state('member_pay_success', {
            url: '/member/pay/success',
            templateUrl: "templates/common/paySuccess.htm",
            params: {integralParam: ''},
            controller: 'IntegralPaySuccessCtrl',
            cache: false,
            requiredLogin: true
        })
        // 我的积分支付失败
        .state('member_pay_error', {
            url: '/member/pay/error',
            templateUrl: "templates/common/payError.htm",
            requiredLogin: true
        })
        //合同验真
        .state('member_checkContract', {
            url: '/member/contract/checkContract',
            templateUrl: "templates/member/contract/checkContract.htm",
            controller: 'CheckContractCtrl',
             cache: false,
            // requiredLogin: true
        })
        //合同详情
        .state('member_checkContractDetail', {
            url: '/member/contract/checkContractDetail',
            templateUrl: "templates/member/contract/checkContractDetail.htm",
            controller: 'CheckContractDetailCtrl',
            cache: false,
            params: {param: ''},
            // requiredLogin: true
        })
        
    /******************* 会员中心 结束 ********************/
    /*******************旅游用品用begin********************/
        // 旅游用品按类别查询商品列表页面
        .state('shop_search', {
            url: '/shop/:desturl',
            templateUrl: "templates/shop/shopSearch.htm",
            //cache: false,
            controller: 'ShopSearchCtrl'
        })
        // 旅游用品商品明细页面
        .state('shop_detail', {
            url: '/shop/detail/:id',
            templateUrl: "templates/shop/shopDetail.htm",
            //cache: false,
            controller: 'ShopDetailCtrl'
        })

        // 旅游用品预订页
        .state('shop_book', {
            url: '/shop/book/booking',
            params: {'loginJumpUrl': 'shop_book', 'bookingData': '@bookingData', 'orderInfo': '@orderInfo'},
            //{param: '@param'},
            templateUrl: "templates/shop/shopBooking.htm",
            controller: 'ShopBookCtrl',
            cache: false,
            requiredLogin: true
        })
    /*******************旅游用品用end********************/
    /*******************常用联系人用begin********************/
        // 常用联系人查询商品列表页面
        .state('traver_list', {
            url: '/member/database/traverListInfo',
            params: {param: '@param'},
            templateUrl: "templates/member/database/traverListInfo.htm",
            cache: false,
            controller: 'TraverListCtrl'
        })
    /*******************常用联系人用end********************/

        // 自由行频道页面跳转开始
        // 自由行详细页
        .state('free_detail', {
            url: '/free/detail/:id',
            templateUrl: "templates/free/detail.htm",
            //params: {param: '@param'},
            params: {'id': '@id', 'addMyFavorite': ''},
            // cache: false,// 预订须知页签点击费用说明后返回到详细页未停留在预订须知 所以去掉cache:false
            controller: 'FreeDetailCtrl'
        })
        // 自由行详细页说明(套餐说明,费用说明,签证信息,预订须知,目的地攻略,签约付款)
        .state('free_detail_description', {
            url: '/free/description/:id/:pageFlag',
            templateUrl: "templates/free/detailDescription.htm",
            params: {param: '@param'},
            controller: 'FreeDetailDescriptionCtrl'
        })
        // 自由行详细页日期选择
        .state('free_detail_date', {
            url: '/free/date/:id',
            templateUrl: "templates/free/detailDate.htm",
            params: {param: '@param'},
            cache: false,
            controller: 'FreeDetailDateCtrl'
        })
        // 自由行服务选择页(交通,酒店(酒店附加产品),旅游附加产品,其他附加产品)
        .state('free_choose', {
            url: '/free/choose',
            templateUrl: "templates/free/choose.htm",
            params: {param: '@param'},
            cache: false,
            controller: 'FreeChooseCtrl'
        })
        // 自由行预订页
        .state('free_book', {
            url: '/free/book',
            templateUrl: "templates/free/book.htm",
            params: {'loginJumpUrl': 'free_book', 'bookingData': '@bookingData', 'orderInfo': '@orderInfo'},
            cache: false,
            controller: 'FreeBookCtrl',
            requiredLogin: true
        })
        // 自由行频道页面跳转结束
        // 票务页面跳转开始
        //票务详细页面
        .state('ticket_detail', {
            url: '/ticket/detail/:routeid',
            templateUrl: "templates/ticket/ticketDetail.htm",
            //cache: false,
            controller: 'TicketDetailCtrl'
        })
        .state('ticket_book', {
            url: '/ticket/book/booking',
            templateUrl: "templates/ticket/ticketBook.htm",
            params: {'loginJumpUrl': 'ticket_book', 'bookingData': '@bookingData', 'orderInfo': '@orderInfo'},
            controller: 'TicketBookCtrl',
            cache: false,
            requiredLogin: true
        })
        // 票务页面跳转结束
        //市场活动页面跳转开始
        .state('market_activity', {
            url: '/market/list/:id',
            templateUrl: "templates/market/marketActivity.htm",
            cache: false,
            controller: 'MarketListCtrl'
        })
        //出行服务页面跳转开始
        .state('travel_services', {
            url: '/travelServices/init',
            templateUrl: "templates/travel/travelServices.htm",
            controller: 'TravelServicesCtrl'
        })
        //市场活动页面跳转结束
        // 活动模板页面跳转start
    .state('activity_template_login', {
        url: '/activity/login/:id',
        templateUrl: "templates/member/activity/activityLogin.htm",
        cache: false,
        controller: 'ActivityLoginCtrl'
    })
    .state('activity_template', {
        url: '/activity/template/:id',
        params: {'newUserFlag': ""},
        templateUrl: "templates/member/activity/activityTemplate.htm",
        cache: false,
        controller: 'ActivityTemplateCtrl'
    })
    .state('activity_result', {
        url: '/activity/:result/:id',
        params: {'shareFlag': ""},
        templateUrl: "templates/member/activity/activityResult.htm",
        cache: false,
        controller: 'ActivityResultCtrl'
    })
    .state('activity_share', {
        url: '/activity/share/:id',
        params: {'shareFlag': ""},
        templateUrl: "templates/member/activity/activityShare.htm",
        cache: false,
        controller: 'ActivityShareCtrl'
    })
    // 活动模板页面跳转end
    /*******************爱旅行start********************/
        .state('ailvxing_list', {
            url: '/ailvxing/list',
            templateUrl: "templates/ailvxing/ailvxingList.htm",
            params: {param: '@param'},
            controller: 'AlxListCtrl'
        })
        .state('ailvxing_detail', {
            url: '/ailvxing/detail/:alxid',
            templateUrl: "templates/ailvxing/ailvxingDetail.htm",
            controller: 'AlxDetailCtrl'
        })
        // 国旅在线服务条款
        .state('help_contract', {
            url: '/help/contract',
            templateUrl: "templates/help/contract.htm"
        })
        // 企业资质
        .state('help_aptitude', {
            url: '/help/aptitude',
            templateUrl: "templates/help/aptitude.htm",
            controller: 'AptitudeCtrl'
        })
        // 企业资质(原生用)
        .state('help_aptitudeNative', {
            url: '/help/aptitudeNative',
            templateUrl: "templates/help/aptitudeNative.htm",
            controller: 'AptitudeCtrl'
        })
        // 网站地图
        .state('help_map', {
            url: '/help/map',
            templateUrl: "templates/help/map.htm"
        })
    /*******************旅行朋友圈start********************/
        .state('travel_add', {
            url: '/travel/add',
            templateUrl: "templates/trip/travelAdd.htm",
            cache: false,
            requiredLogin: true,
            controller: 'CircleAddCtrl',
        })
        .state('travel_circle_index', {
            url: '/travel/circle',
            templateUrl: "templates/trip/travelCircleIndex.htm",
            params: {'backViewId': '@backViewId'},
            //cache: false,
            controller: 'CircleIndexCtrl',
        })
        .state('travel_note_index', {
            url: '/travel/note',
            templateUrl: "templates/trip/travelNoteIndex.htm",
            params: {'backViewId': '@backViewId'},
            //cache: false,
            controller: 'NoteIndexCtrl'
        })
        .state('travel_circle_mine', {
            url: '/travel/circle/mine',
            templateUrl: "templates/trip/travelCircleIndexPerson.htm",
            params: {'backViewId': '@backViewId', 'isPerson': 'true', 'loginJumpUrl': 'travel_circle_mine'},
            controller: 'CircleIndexCtrl',
            //cache: false,
            requiredLogin: true
        })

        .state('travel_note_mine', {
            url: '/travel/note/mine',
            templateUrl: "templates/trip/travelNoteIndexPerson.htm",
            params: {'backViewId': '@backViewId', 'isPerson': 'true', 'loginJumpUrl': 'travel_note_mine'},
            controller: 'NoteIndexCtrl',
            //cache: false,
            requiredLogin: true
        })
        .state('travel_circle_detail', {
            url: '/travel/circle/:ID',
            templateUrl: "templates/trip/travelCircleDetail.htm",
            params: {'backViewId': '@backViewId'},
            cache: false,
            controller: 'CircleDetailCtrl'
        })
        .state('trip_addLike', {
            url: '/trip/ailxindex',
            templateUrl: "templates/trip/traveCircleIndex.htm",
            controller: 'CircleIndexCtrl',
            params: {'backViewId': '@backViewId', 'loginJumpUrl': 'travel_circle_index'}
        })
        .state('travel_note_detail', {
            url: '/travel/note/:ID',
            templateUrl: "templates/trip/travelNoteDetail.htm",
            params: {'backViewId': '@backViewId'},
            cache: false,
            controller: 'NoteDetailCtrl'
        })
        .state('travel_circle_list', {
            url: '/travel/circle/list/:keywords',
            templateUrl: "templates/trip/travelCircleList.htm",
            params: {'backViewId': '@backViewId'},
            controller: 'CircleListCtrl'
        })
        .state('travel_note_list', {
            url: '/travel/note/list/:keywords',
            templateUrl: "templates/trip/travelNoteList.htm",
            params: {'backViewId': '@backViewId'},
            controller: 'NoteListCtrl'
        })
        .state('travel_search', {
            url: '/travel/search',
            templateUrl: "templates/trip/travelSearch.htm",
            params: {'backViewId': '@backViewId', 'searchType': '@searchType'},
            controller: 'TravelSearchCtrl'
        })
        .state('LXQDel', {
            url: '/travel/circle/:ID',
            templateUrl: "templates/trip/travelCircleDetail.htm",
            controller: 'CircleDetailCtrl',
            params: {'backViewId': '@backViewId', 'loginJumpUrl': 'LXQDel'},
            cache: false,
            requiredLogin: true
        })
        .state('YJDel', {
            url: '/travel/circle/:ID',
            templateUrl: "templates/trip/travelNoteDetail.htm",
            controller: 'NoteDetailCtrl',
            params: {'backViewId': '@backViewId', 'loginJumpUrl': 'YJDel'},
            cache: false,
            requiredLogin: true
        })
        .state('travel_circle_index_tologin', {
            url: '/travel/circle',
            templateUrl: "templates/trip/travelCircleIndex.htm",
            params: {'backViewId': '@backViewId', 'loginJumpUrl': 'travel_circle_index_tologin'},
            cache: false,
            controller: 'CircleIndexCtrl',
            requiredLogin: true
        })
        .state('travel_circle_list_tologin', {
            url: '/travel/circle/list/:keywords',
            templateUrl: "templates/trip/travelCircleList.htm",
            params: {'backViewId': '@backViewId', 'loginJumpUrl': 'travel_circle_list_tologin'},
            controller: 'CircleListCtrl',
            requiredLogin: true
        })
    /*******************旅行朋友圈end********************/
        .state('wxPay', {
            url: '/member/wxPay/:orderId/:channel/:price',
            templateUrl: "templates/member/payment/wxPay.htm",
            cache: false,
            controller: 'WxPayCtrl'
        })
        .state('app_message', {
            url: '/app/message/:type',
            templateUrl: "templates/common/appMessage.htm",
            controller: 'AppMessageCtrl'
        })

    /*******************机票酒店 start********************/
        .state('flight_index', {
            url: '/flight/index',
            params: {
                queryData: null,
                lastUrl: ''
            },
            // templateUrl: "templates/flight/flightIndex.htm",
            templateUrl: "templates/flight/flightIndexV2.htm",
            cache: false,
            controller: 'FlightV2Ctrl'
        })

        .state('flight_gj_first', {
            url: '/flight/gj/first',
            params: {queryData: null},
            templateUrl: "templates/flight/gj/gjFlightFirst.htm",
            cache: false,
            controller: 'GjFlightFirstCtrl'
        })

        .state('flight_gj_second', {
            url: '/flight/gj/second',
            params: {queryData: null},
            templateUrl: "templates/flight/gj/gjFlightSecond.htm",
            cache: false,
            controller: 'GjFlightSecondCtrl'
        })

        .state('flight_gn_query', {
            url: '/flight/gn/query',
            params: {queryData: null},
            templateUrl: "templates/flight/gn/gnFlightQuery.htm",
            cache: false,
            controller: 'GnFlightQueryCtrl'
        })

        .state('flight_gj_book', {
            url: '/flight/gj/booking',
            templateUrl: "templates/flight/gj/gjFlightBooking.htm",
            params: {
                'loginJumpUrl': 'flight_gj_book',
                bookingData: '@bookingData',
                'orderInfo': '@orderInfo',
            },
            cache: false,
            requiredLogin: true,
            controller: 'GJFlightBookCtrl'
        })

        .state('flight_gn_book', {
            url: '/flight/gn/booking',
            templateUrl: "templates/flight/gn/gnFlightBooking.htm",
            params: {
                'loginJumpUrl': 'flight_gn_book',
                bookingData: '@bookingData',
                'orderInfo': '@orderInfo',
            },
            cache: false,
            requiredLogin: true,
            controller: 'GNFlightBookCtrl'
        })

            // 机票预订成功页面
            .state('flight_success', {
                url: '/flight/book/success',
                templateUrl: "templates/flight/flightSuccess.htm",
                params: {
                    bookingData: null,
                    flightSearchParam: null
                },
                cache: false,
                controller: 'FlightSuccessCtrl'
            })

            //预订失败页面
            .state('flight_fail', {
                url: '/flight/fail',
                templateUrl: 'templates/flight/flightFail.htm',
                cache: false
            })

            // 机票首页v2.0
            .state('flight_index_v2', {
                url: '/flight/index/v2',
                params: {
                    queryData: null,
                    lastUrl: ''
                },
                templateUrl: "templates/flight/flightIndexV2.htm",
                cache: false,
                controller: 'FlightV2Ctrl'
            })

            // 机票查询v2.0
            .state('flight_gn_query_v2', {
                url: '/flight/gn/query/v2',
                params: {
                    queryData: null,
                    lastUrl: ''
                },
                templateUrl: "templates/flight/gn/gnFlightQueryV2.htm",
                cache: false,
                controller: 'GnFlightQueryV2Ctrl'
            })

            // 机票预订页v2.0
            .state('flight_gn_book_v2', {
                url: '/flight/gn/booking/v2',
                templateUrl: "templates/flight/gn/gnFlightBookingV2.htm",
                params: {
                    'loginJumpUrl': 'flight_gn_book_v2',
                    bookingData: null,
                    'orderInfo': '@orderInfo',
                },
                cache: false,
                requiredLogin: true,
                controller: 'GNFlightBookV2Ctrl'
            })

            // 机票预订失败页面
            .state('flight_fail_v2', {
                url: '/flight/fail/v2',
                templateUrl: 'templates/flight/flightFailV2.htm',
                params: {
                    errorInfo: null,
                    flightSearchParam: null
                },
                cache: false,
                controller: 'FlightFailV2Ctrl'
            })

            .state('hotel_index', {
                url: '/hotel/index',
                templateUrl: "templates/hotel/hotelIndex.htm",
                cache: false,
                controller: 'HotelCtrl'
            })
            //国际酒店 列表页
            .state('ihotel_list', {
                url: '/ihotel/list/:url',
                params: {queryData: null},
                cache: false,
                templateUrl: "templates/hotel/gj/ihotelList.htm",
                controller: 'iHotelListCtrl'
            })
            .state('ihotel_detail', {
                url: '/ihotel/detail/:url',
                templateUrl: "templates/hotel/gj/ihotelDetail.htm",
                cache: false,
                controller: 'IHotelDetailCtrl'
            })
            .state('hotel_detail', {
                url: '/hotel/detail/:url',
                templateUrl: "templates/hotel/gn/hotelDetail.htm",
                cache: false,
                controller: 'HotelDetailCtrl'
            })
            .state('hotel_list', {
                url: '/hotel/list/:url',
                params: {queryData: null},
                templateUrl: "templates/hotel/gn/hotelList.htm",
                cache: false,
                controller: 'HotelListCtrl'
            })
            .state('hotel_book', {
                url: '/hotel/book',
                templateUrl: "templates/hotel/hotelBook.htm",
                params: {loginJumpUrl: 'hotel_book', orderInfo: '@orderInfo', bookingData: '@bookingData'},
                cache: false,
                requiredLogin: true,
                controller: 'HotelBookCtrl'
            })
            //预订成功页面
            .state('hotel_success', {
                url: '/hotel/success',
                templateUrl: 'templates/hotel/hotelSuccess.htm',
                cache: false,
                params: {orderParam: '@orderParam'},
                controller: 'HotelSuccessCtrl'
            })
            //预订成功页面
            .state('hotel_fail', {
                url: '/hotel/fail',
                templateUrl: 'templates/hotel/hotelFail.htm',
                cache: false
            })
            //BITE发码及抽奖
            .state('biteCoupon', {
                url: '/market/biteCoupon',
                templateUrl: 'templates/market/biteCoupon.htm',
                cache: false,
                controller: 'BiteGetCouponCtrl',
                requiredLogin: true
            })

        //进入抽奖页面
        .state('draw_index', {
            url: '/draw/:drawId',
            templateUrl: 'templates/common/draw.htm',
            cache: false,
            params: {'drawId': null, 'drawParam': null},
            controller: 'DrawCtrl',
            requiredLogin: true
        })

        .state('biteSign', {
            url: '/market/biteSign',
            templateUrl: 'templates/market/biteSign.htm',
            cache: false,
            controller: 'BiteSignCtrl',
            requiredLogin: true
        })

        //app下载地址
        .state('appDownload', {
            url: '/app/download',
            templateUrl: 'templates/common/appload.htm',
            controller: 'AppDownloadCtrl'
        })
            //app下载地址
            .state('appNewsDownload', {
                url: '/app/news/download',
                templateUrl: 'templates/common/appNewsLoad.htm',
                controller: 'AppNewsDownloadCtrl'
            })
        // 银联刷卡-用卡奖励
        .state('unionPay_ad', {
            url: '/unionPay2015/ad',
            templateUrl: 'templates/unionPay/unionAdPage.htm',
            controller: 'UnionPayCtrl'
        })
        // 银联刷卡
        .state('unionPay_collectInfo', {
            url: '/unionPay2015/collectInfo',
            templateUrl: 'templates/unionPay/searchForTeamNew.htm',
            controller: 'UnionPayCtrl'
        })

        //实体卡激活广告
        .state('cardActivation_ad', {
            url: '/cardActivation/ad',
            controller: 'CardActivationCtrl',
            templateUrl: 'templates/member/cardActivation/cardAd.htm'
        })
        // 实体卡激活
        .state('cardActivation_activate', {
            url: '/cardActivation/activate',
            templateUrl: 'templates/member/cardActivation/cardActivate.htm',
            controller: 'CardActivationCtrl',
            requiredLogin: true
        })
        //客服着陆页
        .state('kefu_home',{
            url: '/kefu',
            templateUrl: 'templates/common/onlineQa.htm',
            cache: false,
            controller: 'KeFuHomeCtrl'
        })
        // 客服首页
        .state('kefu_index', {
            url: '/kefu/index',
            templateUrl: 'templates/common/kefuIndex.htm',
            controller: 'KeFuCtrl'
        })
            // 关于我们
            .state('about_us', {
                url: '/about/index',
                templateUrl: 'templates/common/aboutUs.htm',
                controller: 'AboutUsCtrl'
            })
        // 客户满意度调查-去评价
        .state('goToEvalute', {
            url: '/evalute/goToEvalute',
            templateUrl: 'templates/evalute/evaluteIndex.htm',
            controller: 'EvaluteCtrl',
            cache: false,
            requiredLogin: true,
            params: {evaluteParam: '@evaluteParam'}
        })
        // 客户满意度评价成功
        .state('evaluteSucc', {
            url: '/evalute/evaluteSucc',
            templateUrl: 'templates/evalute/evaluteSucc.htm',
            controller: 'EvaluteSuccCtrl',
            cache: false,
            requiredLogin: true,
            params: {evaluteParam: '@evaluteParam'}
        })
            .state('trainList', {
                url: '/train/trainList',
                templateUrl: 'templates/train/trainList.htm',
                controller: 'TrainListCtrl',
                cache: true,
                params: {queryData: null}
            })
            //火车票详细处理
            .state('trainDetail', {
                url: '/train/trainDetail',
                templateUrl: 'templates/train/trainDetail.htm',
                controller: 'TrainDetailCtrl',
                cache: true,
                params: {queryData: null}
            })

        /***********小黄车广告****************/
        .state('ofo_ad', {
            url: '/ofo/ad',
            templateUrl: 'templates/ad/ofoAd.htm',
            controller: 'OfoAdCtrl',
            cache: false,
            requiredLogin: true
        })
	        /***********线路详细页领取优惠券页面************/
        .state('coupon_detail', {
            url: '/common/couponDetail/:routeId',
          templateUrl: 'templates/common/couponDetail.htm',
          controller: 'CouponDetailCtrl',
          cache: false,
          requiredLogin: true,
            params: {routeId: '@routeId'}
        })
    .state('disney_cashconpon', {
        url: '/disney/cashconpon/:QRCodeKey',
        cache: false,
        templateUrl: "templates/member/login/disneycashconpon.htm",
        controller: 'DisneyCashconponCtrl'
    })
    .state('disney_qrcode_img', {
        url: '/disney/qrcodeimg/:key',
        cache: false,
        params: {key: '@key'},
        templateUrl: "templates/member/login/disneyqrcodeimg.htm",
        controller: 'DisneyQrcodeImgCtrl'
    })

        /************慧生活平台跳转注册*********/
        .state('hshVip_register', {
            url: '/member/hshVipRegister',
            cache: false,
            params: {mobile: null},
            templateUrl: "templates/member/register/hshVipRegister.htm",
            controller: "HshVipRegisterCtrl"
        })
    /*****星赏会积分兑换支付*****/
        .state('starPay_success', {
            url: '/star/pay/success/:integralVal/:orderPrice/:integralPayPrice/:orderId/:channel',
            cache: false,
            templateUrl: "templates/common/starIntegralPaySuccess.htm",
            controller: 'StarIntegralCtrl'
        })

        .state('starPay_error', {
            url: '/star/pay/error',
            cache: false,
            templateUrl: "templates/common/starIntegralPayError.htm",
            controller: 'StarIntegralCtrl'
        })

        .state('starExchange_error', {
            url: '/star/exchange/error',
            cache: false,
            templateUrl: "templates/common/starIntegralExchangeError.htm",
            controller: 'StarIntegralCtrl'
        })

        /************线下门市网络*********/
        .state('store_list', {
            url: '/store/list',
            cache: false,
            params: {currentCityCode: '@currentCityCode', currentCityName: '@currentCityName'},
            templateUrl: "templates/citsstore/storelist.htm",
            controller: 'StoreCtrl'
        })
        //光大银行办卡链接上增加代码
        .state('bank_monitor', {
            url: '/bank/monitor/:reqCardId',
            cache: false,
            params: {reqCardId: '@reqCardId'},
            templateUrl: "",
            controller: 'BankMonitorCtrl'
        })
        .state('store_detail', {
            url: '/store/detail/:storeid',
            cache: false,
            params: {orderFlag: '@orderFlag'},
            templateUrl: "templates/citsstore/storedetail.htm",
            controller: 'StoreDetailCtrl'
        })
        .state('store_city_list', {
            url: '/store/city/list',
            cache: false,
            params: {currentCity: '@currentCity'},
            templateUrl: "templates/citsstore/storecity.htm",
            controller: 'StoreCityCtrl'
        })
        .state('store_map', {
            url: '/store/map/:currentLocation',
            cache: false,
            // params: {currentLocation: '@currentLocation'},
            templateUrl: "templates/citsstore/storemap.htm",
            controller: 'StoreMapCtrl'
        })
        .state('store_around', {
            url: '/store/around/:currentCityCode',
            cache: false,
            params: {storeList: '@storeList'},
            templateUrl: "templates/citsstore/storearound.htm",
            controller: 'StoreAroundCtrl'
        })

    .state('syh_guolv', {
        url: '/syh/guolv',
        templateUrl: 'templates/ad/syhGuolv.htm',
        controller: 'SyhGuolvCtrl',
        cache: false
    })
    .state('syh_zhonglv', {
        url: '/syh/zhonglv',
        templateUrl: 'templates/ad/syhZhonglv.htm',
        controller: 'SyhZhonglvCtrl',
        cache: false
    })
        // 在线问答
        .state('member_faqListNew', {
            url: '/member/faqNew/list',
            templateUrl: "templates/member/faq/faqListNew.htm",
            cache: false,
            controller: 'myFaqCtrl',
            requiredLogin: true
            })
            //火车票
            .state('train_index', {
                url: '/train/index',
                templateUrl: "templates/train/trainIndex.htm",
                cache: true,
                params: {queryData: null},
                controller: 'TrainCtrl'
            })

            .state('train_book', {
                url: '/train/booking',
                templateUrl: "templates/train/model/trainBooking.htm",
                params: {
                    'loginJumpUrl': 'train_book',
                    bookingData: '@bookingData',
                    'orderInfo': '@orderInfo',
                },
                cache: false,
                requiredLogin: true,
                controller: 'TrainBookCtrl'
            })

            .state('train_order_detail', {
                url: '/train/orderInfo/:orderId',
                templateUrl: "templates/train/model/trainOrderDetail.htm",
                params: {payFlay: '@payFlay'},
                cache: false,
                requiredLogin: true,
                controller: 'TrainOrderCtrl'
            })
            .state('trainTraver_list', {
                url: '/train/model/trainTraverListInfo',
                params: {param: '@param'},
                templateUrl: "templates/train/model/trainTraverListInfo.htm",
                cache: false,
                controller: 'TraverListCtrl'
            })

            .state('trainStopInfo', {
                url: '/train/model/trainTraverListInfo',
                params: {queryData: '@queryData'},
                templateUrl: "templates/train/model/trainStopInfo.htm",
                cache: true,
                controller: 'trainStopInfoCtrl'
        });
                    $httpProvider.interceptors.push('httpInterceptor');


    /*******************机票酒店 end********************/
        // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/home');
}]);

citsApp.factory('Cookies',['$cookies',function ($cookies) {
  
    var defaultOption = { path:'/',domain: 'm.ourtour.com'};

    //var defaultOption = { path:'/'};
    return {
        set: function (key, data) {
            var expireDate = new Date();
            expireDate.setDate(expireDate.getDate() + 30);
            defaultOption.expires=expireDate;
            return $cookies.put(key, data,defaultOption);
        },
        setFiveMinute: function (key, data) {
            var expireDate = new Date();
            expireDate.setTime(expireDate.getTime() + 5*60*1000);
            defaultOption.expires = expireDate;
            return $cookies.put(key, data, defaultOption);
        },
        setOneDay: function (key, data) {
            var expireDate = new Date();
            expireDate.setDate(expireDate.getDate() + 1);
            defaultOption.expires = expireDate;
            return $cookies.put(key, data, defaultOption);
        },
        get: function (key) {
            return $cookies.get(key);
        },
        remove: function (key) {
            return $cookies.remove(key,defaultOption);
        }
    };
}]);

citsApp.factory('Storage', function () {
    return {
        set: function (key, data) {
            return CITS.Storage.set(key, data);
        },
        get: function (key) {
            return CITS.Storage.get(key);
        },
        remove: function (key) {
            return CITS.Storage.remove(key);
        }
    };
});
citsApp.factory('Session', function () {
    return {
        set: function (key, data) {
            return CITS.Session.set(key, data);
        },
        get: function (key) {
            return CITS.Session.get(key);
        },
        remove: function (key) {
            return CITS.Session.remove(key);
        }
    };
});
citsApp.factory('ServiceFactory', ['$resource', 'ENV', function ($resource, ENV) {
    return $resource(ENV.api, {}, {
        api: {
            method: 'post',
            params: {
                requestHeader: '@requestHeader',
                requestBody: '@requestBody'
            }
        }
    });
}]);
citsApp.factory('SearchServiceFactory', ['$resource', 'ENV', function ($resource, ENV) {
    return $resource(ENV.alapi, {}, {
        api: {
            method: 'post',
            params: {
                requestHeader: '@requestHeader',
                requestBody: '@requestBody'
            }
        }
    });
}]);
citsApp.factory('DataServiceFactory', ['$resource', 'ENV', function ($resource, ENV) {
    return $resource(ENV.dataapi, {}, {
        api: {
            method: 'POST',
            data: {
                requestHeader: '@requestHeader',
                requestBody: '@requestBody'
            }
        }
    });
}]);
citsApp.factory('httpInterceptor', ['HostFactory', 'Session', 'ENV', '$q', '$injector', function (HostFactory, Session, ENV, $q, $injector) {
    var httpInterceptor = {
        request: function (config) {

            if (config.url.indexOf('api.html') > 0) {

                var host = HostFactory.getHostDomain();
                var csrfToken = Session.get(ENV.CSRF_TOKEN_KEY);
                var userInfo = $injector.get('CommonFactory').getUserInfo() || "";

                config.params.requestHeader.site = HostFactory.getHostDomain();
                config.params.requestHeader.user = CITS.getUser();
                config.params.requestHeader.csrfToken = csrfToken;
                config.params.requestHeader.deviceId = CITS.info.unique;

                if (userInfo) {
                    config.params.requestHeader.loginToken = userInfo.loginToken;
                    config.params.requestHeader.loginId = userInfo.loginId;
                }
            }else if(config.url.indexOf('data.html') > 0  ){
                var host = HostFactory.getHostDomain();
                var csrfToken = Session.get(ENV.CSRF_TOKEN_KEY);
                var userInfo = $injector.get('CommonFactory').getUserInfo() || "";

                config.data.requestHeader.site = HostFactory.getHostDomain();
                config.data.requestHeader.user = CITS.getUser();
                config.data.requestHeader.csrfToken = csrfToken;
                config.data.requestHeader.deviceId = CITS.info.unique;

                if (userInfo) {
                    config.data.requestHeader.loginToken = userInfo.loginToken;
                    config.data.requestHeader.loginId = userInfo.loginId;
                }
            }
            return config;
        },
        response: function (config) {
            state = $injector.get('$state');
            if (!config) {
                $injector.get('$state').go("net");
            }

            if (config.config.url.indexOf('api.html') > 0|| config.config.url.indexOf('data.html') > 0){
                var msgId = config.data.msgId;
                if (msgId == '0') {
                    $injector.get('$state').go("member_login");
                    return $q.reject(config);
                } else if (msgId == '2') {
                    $injector.get('$state').go("auth");
                    return $q.reject(config);
                    // return config;
                } else if (msgId == '8') {
                    HostFactory.removePersonShopUser();
                    $injector.get('$state').go("werror");
                    return $q.reject(config);
                    // return config;
                } else if (msgId == '9') {
                    $injector.get('$state').go("error");
                    return $q.reject(config);
                    // return config;
                } else if (msgId == '1' && (config.config.url.indexOf('app/api.html') > 0|| config.config.url.indexOf('data.html') > 0)) {
                    Session.set(ENV.CSRF_TOKEN_KEY, config.data.csrfToken);
                }

            }
            return config;
        }
        ,
        requestError: function (config) {
            $injector.get('$rootScope').$broadcast('loading:hide');
            console.log("requestError:" + config);
            $injector.get('$state').go("net");
        }
        ,
        responseError: function (config) {
            $injector.get('$rootScope').$broadcast('loading:hide');
            console.log("responseError:" + config);

            //$injector.get('$state').go("net");
            return config;

        }
    };

    return httpInterceptor;
}]);
